app.controller('addupdateinternetcontroller', function($scope, $state, $translate, DB, InternetSharedProperties, $ionicPopup, UTIL_SERVICE, websiteService) {

        $scope.internet = {
          id : "",
          builtin : "0",
          name : "",
          description : "",
          link : ""
        };

        $scope.editMode = false;
        $scope.triggeredButton = false;
        $scope.buttonName = $translate.instant('SAVE');
        $scope.headerTitle = $translate.instant('NOUVELLE_ADD_INTERNET');
        
        $scope.init = function() {
          
          var intnet = InternetSharedProperties.getInternet();
          if(intnet != null) {
              $scope.internet = intnet;
              $scope.editMode = true;
              $scope.headerTitle = $translate.instant('HEADER_EDIT_INTERNET');
          } else {
              $scope.editMode = false;
          }
        };

        $scope.saveInternet = function() {
          $scope.triggeredButton = true;
         // ADB.trackState($translate.instant('SEPA_CONTACT_INTERNET_ADDNEW_AJOUTER'));
          if($scope.isValidInput()){
            ADB.trackState($translate.instant('SEPA_CONTACT_LIST_INTERNET'));
              var oldInternetData = InternetSharedProperties.getInternet();
              if(oldInternetData == null) {
                  if($scope.internet.description == 'undefined') {
                    $scope.internet.description = "";
                  }

                  if($scope.internet.descriptionUi == undefined) {
                      $scope.internet.descriptionUi = "";
                  }
                  
                  var description = $scope.internet.name + "%SEPA%" + $scope.internet.descriptionUi;
                  $scope.internet.description = description;
                  
                  //New Internet Data
                  websiteService.insertWebDetails($scope.internet).then(function(result) {
                      $state.go('app.internetlist');   
                      ADB.trackState($translate.instant('SEPA_CONTACT_LIST_INTERNET'));                             
                  },function(error) {
                      console.log("Error Inserting Internet : "+error);
                      $ionicPopup.alert({
                          title: 'Error',
                          template: 'Unable to add internet'
                      });
                  });
              
              } else {

                 //Modify Internet Data
                 var oldInternetRec = websiteService.getWebsiteDetails(oldInternetData.id);
                 $scope.editInternetContacts(oldInternetRec);
                    
              }
          }
        };

        $scope.isValidInput=function(){
              if($scope.internet.name===null || $scope.internet.name==="" ){
                $scope.triggeredButton = false;
                $ionicPopup.show({
                            cssClass:'form-alert-popup',
                            buttons: [
                                            { 
                                                text: $translate.instant('SEP_EXIT_OK'), 
                                                type:'button-default first-button last-button',
                                                onTap: function(e) {
                                                    
                                                }
                                            } 
                                     ],
                            template: $translate.instant('MSG_NOM_REQUIRED')
                });
                return false;
              } else if($scope.internet.link===null || $scope.internet.link===""){
                $scope.triggeredButton = false;
                $ionicPopup.show({
                            cssClass:'form-alert-popup',
                            buttons: [
                                            { 
                                                text: $translate.instant('SEP_EXIT_OK'), 
                                                type:'button-default first-button last-button',
                                                onTap: function(e) {
                                                    
                                                }
                                            } 
                                     ],
                            template: $translate.instant('MSG_WEB_REQUIRED')
                });
                return false;
              }else if(!UTIL_SERVICE.isValidWeb($scope.internet.link)){
                $scope.triggeredButton = false;
                $ionicPopup.show({
                            cssClass:'form-alert-popup',
                            buttons: [
                                            { 
                                                text: $translate.instant('SEP_EXIT_OK'), 
                                                type:'button-default first-button last-button',
                                                onTap: function(e) {
                                                    
                                                }
                                            } 
                                     ],
                            template: $translate.instant('MSG_INVALID_WEB')
                });
                return false;
              } else {
                return true;
              }
        }

        $scope.editInternetContacts = function(oldInternetRec) {

                  if($scope.internet.description == 'undefined') {
                    $scope.internet.description = "";
                  }
                  
                  if($scope.internet.descriptionUi == undefined) {
                      $scope.internet.descriptionUi = "";
                  }
                  var description = $scope.internet.name + "%SEPA%" + $scope.internet.descriptionUi;
                  $scope.internet.description = description;

                  websiteService.updateWebDetails($scope.internet).then(function(result) {
                      $state.go('app.internetlist');  
                      ADB.trackState($translate.instant('SEPA_CONTACT_LIST_INTERNET'));                              
                  },function(error) {
                      console.log("Error Updating Internet : "+error);
                      $ionicPopup.alert({
                          title: 'Error',
                          template: 'Unable to add internet'
                      });
                  });
        };

        $scope.editInternet = function() {
//          ADB.trackState($translate.instant('SEPA_CONTACT_INTERNET_ADDNEW_MODIFIER'));
          $scope.editMode = false;
          $scope.buttonName = $translate.instant('VALIDER');
        }

        $scope.cancelInternet = function(){
//          ADB.trackState($translate.instant('SEPA_CONTACT_INTERNET_ADDNEW_ANNULER'));
          $state.go('app.internetlist');
           ADB.trackState($translate.instant('SEPA_CONTACT_LIST_INTERNET'));
        }

})

.service('InternetSharedProperties', function () {
    var property = null;

    return {
        getInternet: function () {
            return property;
        },
        setInternet: function(value) {
            property = value;
        }
    };

});