// Ionic Starter App
// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
var app = angular.module('SEPAgenda', ['ionic', 'ngIOS9UIWebViewPatch', 'SEPAgenda.services', 'pascalprecht.translate', 'ui.rCalendar', 'ngCordova', 'ngSanitize', 'angular-carousel','util.services','splash', 'events', 'contacts', 'treatments', 'preparemyconsultation', 'LocalNotification.services'])
    .controller('SEPAgendaController', function() {

           // ADB.trackState("SPLASH SCREEN");

        /*$cordovaPreferences.fetch('key').success(function(value) {
                if(value == 'migrationdone') {
                    console.log("Migration Done");
                } else {
                    DB.init();
                    DB.loadDefaultValues();

                    $cordovaPreferences.store('key', 'migrationdone').success(function(value) {
                        alert("Preference stored value : " + value);
                    }).error(function(error) {
                        alert("Error while storing in preferences : " + error);
                    })
                    
                }
                alert("Fetching preference key success: " + value);
        }).error(function(error) {
            alert("Fetching preference key error: " + error);
        })*/
    });

app.run(function($ionicPlatform, DB, $state, $ionicPopup, $translate,$cordovaSplashscreen, notificationutil) {
    $ionicPlatform.ready(function() {
        ADB.trackState("SPLASH SCREEN");
        // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
        // for form inputs)
        if (window.cordova && window.cordova.plugins.Keyboard) {
            cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
            cordova.plugins.Keyboard.disableScroll(true);
        }
        if (window.StatusBar) {
            // org.apache.cordova.statusbar required
            StatusBar.styleLightContent();
        }
        $cordovaSplashscreen.hide();

        var migrationValue = window.localStorage['migration'];
        if(migrationValue == 'done') {
            console.log("Migration Done");
        } else {
            DB.init();
            DB.loadDefaultValues();
            window.localStorage['migration'] = 'done';
            localStorage.setItem("triggerReminderForMigration", true);

        }

        moment.locale("fr");            

        //Init InAppBrowser object
         window.open = cordova.InAppBrowser.open;

        $ionicPlatform.on('resume', function() {
            if ($state.current.url === '/mainscreen') {
                $state.reload();
            }
        });
    });

    $ionicPlatform.registerBackButtonAction(function() {
      if($state.current.name==='home' || $state.current.name==='welcome'){
            navigator.app.exitApp();
//                                            
//        $ionicPopup.confirm({
//            template: $translate.instant('SEP_EXIT_ALERT'),
//            okText: $translate.instant('SEP_EXIT_OK'),
//            cancelText: $translate.instant('SEP_EXIT_CANCEL')
//        }).then(function(res) {
//            if (res) {
//                navigator.app.exitApp();
//            }
//        });
      } else if ($state.current.name === 'settingsFromTreatment'){
            $state.go('app.addtreatment.dosage');
      } else if($state.current.name==='pictogramquestion'){
            console.log("Action");
      } else if($state.current.name==='guide' || $state.current.name==='cgu' || $state.current.name==='sharescreen'){
        navigator.app.backHistory();
      }
    }, 100);
        
   });


app.config(function($ionicConfigProvider) {
    $ionicConfigProvider.views.swipeBackEnabled(false);
});

app.directive('compile', ['$compile', function ($compile) {
  return function(scope, element, attrs) {
    scope.$watch(
      function(scope) {
        return scope.$eval(attrs.compile);
      },
      function(value) {
        element.html(value);
        $compile(element.contents())(scope);
      }
   )};
  }]);

app.config(function($stateProvider, $urlRouterProvider) {
    $stateProvider
    
    .state('app', {
            url: "/menu",
        views: {
            'containerView': {
                abstract: true,
                templateUrl: 'templates/menu.html',
                controller: 'appCtrl'
            }
        }
    })

    .state('splash', {
        url: "/splash",
        views: {
            'containerView': {
                templateUrl: 'modules/splash/templates/splash.html',
                controller: 'splashCtrl'
            }
        }
    })

    .state('guide', {
        url: "/guide",
        views: {
            'containerView': {
                templateUrl: 'templates/guide.html',
                controller: 'guideCtrl'
            }
        }
    })

     .state('app.guideinfo', {
        url: "/guideinfo",
        views: {
            'menuContent': {
                templateUrl: 'templates/guide.html',
                controller: 'guideCtrl'
            }
        }
    })
  
    .state('cgu', {
        url: "/cgu",
        views: {
            'containerView': {
                templateUrl: 'templates/cgu.html',
                controller: 'cguCtrl'
            }
        }
    })
    .state('app.cguinfo', {
        url: "/cguinfo",
        views: {
            'menuContent': {
                templateUrl: 'templates/cgu.html',
                controller: 'cguCtrl'
            }
        }
    })

    .state('home', {
        url: "/home",
        cache: false,
        views: {
            'containerView': {
                templateUrl: 'templates/home.html',
                controller: 'homecontroller'
            }
        }
    })

    .state('welcome', {
        url: "/welcome",
        cache: false,
        views: {
            'containerView': {
                templateUrl: 'templates/welcome.html',
                controller: 'welcomecontroller'
            }
        }
    })
    
    .state('sharescreen', {
        url: "/sharescreen",
        cache: false,
        views: {
            'containerView': {
                templateUrl: 'templates/sharescreen.html',
                controller: 'sharecontroller'
            }
        }
    })

    .state('app.info', {
        url: "/info",
        views: {
            'menuContent': {
                templateUrl: 'templates/info.html',
                controller: 'infopagecontroller'
            }
        }
    })
    
    .state('app.dashboard', {
        url: "/dashboard",
        views: {
            'menuContent': {
                templateUrl: 'templates/dashboard.html',
                controller: 'dashboardcontroller'
            }
        }
    })

    .state('app.tipoftheweek', {
        url: "/tipoftheweek",
        views: {
            'menuContent': {
                templateUrl: 'templates/tipoftheweek.html',
                controller: 'dashboardcontroller'
            }
        }
    })
           
   .state('app.settings', {
                  url: '/settings',
                  views: {
                  'menuContent': {
                  templateUrl: 'templates/settings.html',
                  controller: 'settingscontroller'
                  }
                  }
                  })

   .state('settingsFromTreatment', {
                  url: '/settingsFromTreatment',
                  views: {
                  'containerView': {
                  templateUrl: 'templates/settingsFromTreatment.html',
                  controller: 'settingscontroller'
                  }
                  }
                  })
           
    .state('app.agenda', {
        url: "/agenda",
        views: {
                'menuContent': {
                templateUrl: 'templates/agendascreen.html',
                controller: 'agendacontroller'
            }
           }
        })
    
    .state('app.agenda.events', {
        url: "/agendaevents",
        views: {
                'events-tab': {
                templateUrl: 'templates/agendaevents.html',
                controller: 'MyCtrl'
            }
           }
        })
    
    .state('app.agenda.adress', {
        url: "/agendaaddress",
        views: {
                'address-tab': {
                templateUrl: 'templates/agendaadress.html',
                controller: 'agendaaddresscontroller'
            }
           }
        })
    .state('app.agenda.calendar', {
        url: "/calendar",
        cache: false,
        views: {
            'address-calendar': {
                templateUrl: 'templates/calendar.html',
                controller: 'calendarcontrol'
            }
        }
    })
    .state('app.preparemyconsultation', {
        url: "/preparemyconsultation",
        views: {
                'menuContent': {
                templateUrl: 'templates/preparemyconsultation.html',
                controller: 'preparemyconsultationcontroller'
            }
           }
        })
    .state('app.preparemyconsultationconceils', {
        url: "/preparemyconsultationconceils",
        cache: false,
        views: {
                'menuContent': {
                templateUrl: 'templates/preparemyconsultationconceils.html',
                controller: 'pmcconseilscontroller'
            }
           }
        })
    .state('app.preparemyconsultinfo', {
        url: "/preparemyconsultinfo",
        cache: false,
        views: {
                'menuContent': {
                templateUrl: 'templates/preparemyconsultinfo.html',
                controller: 'preparemycolsultinfocontroller'
            }
           }
        })
   
    .state('app.recommendationhome', {
                url: "/recommendationhome",
                views: {
                'menuContent': {
                templateUrl: 'templates/recommendationhome.html',
                controller: 'recommendationhomecontroller'
            }
        }
    })
    .state('app.addevent',{
        url: "/addevent",
        views: {
            'menuContent': {
                templateUrl: 'templates/addagendaevent.html',
                controller: 'addeventcontroller'
            }
        }
    })
    .state('app.addevent.fromCalendar',{
        url: "/addeventFromCalendar",
        views: {
            'menuContent': {
                templateUrl: 'templates/addagendaevent.html',
                controller: 'addeventcontroller'
            }
        }
    })
    .state('app.addevent.fromDashboard',{
        url: "/addeventFromDashboard",
        views: {
            'menuContent': {
                templateUrl: 'templates/addagendaevent.html',
                controller: 'addeventcontroller'
            }
        }
    })
    .state('app.recommendationinfo', {
                url: "/recommendationinfo",
                views: {
                'menuContent': {
                templateUrl: 'templates/recommendationinfo.html',
                controller: 'recommendationinfocontroller'
            }
        }
    }).state('app.professionallist',{
        url: "/professionallist",
        views: {
            'menuContent': {
                templateUrl: 'templates/professionallist.html',
                controller: 'professionallistcontroller'
            }
        }
    }).state('app.associationlist',{
        url: "/associationlist",
        views: {
            'menuContent': {
                templateUrl: 'templates/associationlist.html',
                controller: 'associationlistcontroller'
            }
        }
    }).state('app.healthnetworklist',{
        url: "/healthnetworklist",
        views: {
            'menuContent': {
                templateUrl: 'templates/healthnetworklist.html',
                controller: 'healthnetworklistcontroller'
            }
        }
    }).state('app.internetlist',{
        url: "/internetlist",
        views: {
            'menuContent': {
                templateUrl: 'templates/internetlist.html',
                controller: 'internetcontroller'
            }
        }
    }).state('app.addprofessionals',{
        url: "/addprofessionals",
        views: {
            'menuContent': {
                templateUrl: 'templates/addprofessionals.html',
                controller: 'addprofessionalscontroller'
            }
        }
    }).state('app.addassociations',{
        url: "/addassociations",
        views: {
            'menuContent': {
                templateUrl: 'templates/addassociations.html',
                controller: 'addassociationscontroller'
            }
        }
    }).state('app.addinternet',{
        url: "/addinternet",
        views: {
            'menuContent': {
                templateUrl: 'templates/addinternet.html',
                controller: 'addupdateinternetcontroller'
            }
        }
    }).state('app.addprofessionals.fromhome',{
        url: "/addprofessionals",
        views: {
            'menuContent': {
                templateUrl: 'templates/addprofessionals.html',
                controller: 'addprofessionalscontroller'
            }
        }
    }).state('app.addassociations.fromhome',{
        url: "/addassociations",
        views: {
            'menuContent': {
                templateUrl: 'templates/addassociations.html',
                controller: 'addassociationscontroller'
            }
        }
    }).state('app.addinternet.fromhome',{
        url: "/addinternet",
        views: {
            'menuContent': {
                templateUrl: 'templates/addinternet.html',
                controller: 'addupdateinternetcontroller'
            }
        }
    }).state('app.mytreatments',{
        url: "/mytreatments",
        views: {
            'menuContent': {
                templateUrl: 'templates/mytreatments.html',
                controller: 'mytreatmentscontroller'
            }
        }
    }).state('app.mytreatments.longterm',{
        url: "/treatmentlongterm",
        views: {
                    'treatments-longterm-tab': {
                        templateUrl: 'templates/mytreatmentslongterm.html',
                        controller: 'mytreatmentslongtermcontroller'
                    }
        }
    }).state('app.mytreatments.symptoms',{
        url: "/treatmentsymptoms",
        views: {
                    'treatments-symptoms-tab': {
                        templateUrl: 'templates/mytreatmentssymptoms.html',
                        controller: 'mytreatmentssymptomscontroller'
                     }
        }
    }).state('app.addtreatment',{
        url: "/addtreatment",
        views: {
            'menuContent': {
                templateUrl: 'templates/addtreatment.html',
                controller: 'addtreatmentcontroller'
            }
        }
    }).state('app.addtreatment.medication',{
        url: "/medication",
        views: {
                    'addtreatment-medication': {
                        templateUrl: 'templates/addtreatmentmedication.html'
                    }
        }
    }).state('app.addtreatment.dosage',{
        url: "/dosage",
        views: {
                    'addtreatment-dosage': {
                        templateUrl: 'templates/addtreatmentdosage.html'
                     }
        }
    }).state('app.addtreatment.packaging',{
        url: "/packaging",
        views: {
                    'addtreatment-packaging': {
                        templateUrl: 'templates/addtreatmentpackaging.html'
                     }
        }
    }).state('app.pictogramcompleted',{
        url: "/pictogram",
        views: {
            'menuContent': {
                templateUrl: 'templates/pictogramcompleted.html',
                controller: 'pictogramcontroller'
            }
        }
    }).state('pictogram',{
        url: "/pictogram",
        views: {
            'containerView': {
                templateUrl: 'templates/pictogram.html',
                controller: 'pictogramcontroller'
            }
        }
    }).state('pictogramquestion',{
        url: "/pictogramsurvey",
        views: {
            'containerView': {
                templateUrl: 'templates/pictogramquestion.html',
                controller: 'pictogramquestioncontroller'
            }
        }
    });
    
    // if none of the above states are matched, use this as the fallback
    $urlRouterProvider.otherwise('/splash');
});

app.directive('elastic', [
    '$timeout',
    function($timeout) {
        return {
            restrict: 'A',
            link: function($scope, element) {
                $scope.initialHeight = $scope.initialHeight || element[0].style.height;
                var resize = function() {
                    element[0].style.height = $scope.initialHeight;
                    element[0].style.height = "" + element[0].scrollHeight + "px";
                };
                element.on("input change", resize);
                $timeout(resize, 0);
            }
        };
    }
]);


app.config(['$translateProvider', function($translateProvider) {
    $translateProvider.useStaticFilesLoader({
        prefix: 'languages/locale-',
        suffix: '.json'
    });
    $translateProvider.preferredLanguage('en_US'); //en_US,nl_NL
}]);

//Empty screen avoid
app.config(function($ionicConfigProvider) {
           $ionicConfigProvider.views.transition('none');
           $ionicConfigProvider.navBar.alignTitle('center');
           $ionicConfigProvider.views.forwardCache(true);
           $ionicConfigProvider.views.maxCache(0);
           });

