angular.module('SEPAgenda.config', []).constant('DB_CONFIG', {
    name: 'db11.db',
    version: '1.0',
    tables: [{
        name: 'AppInfos',
        columns: [{
            name: 'id',
            type: 'integer PRIMARY KEY AUTOINCREMENT'
        },{
            name: 'fl',
            type: 'text'
        },{
            name: 'patientDisclaimer',
            type: 'text'
        },{
            name: 'contactDisclaimer',
            type: 'text'
        },{
            name: 'websiteDisclaimer',
            type: 'text'
        },{
            name: 'wt',
            type: 'integer'
        },{
            name: 'ar',
            type: 'integer'
        }]
        },{
        name: 'Appointment',
        columns: [{
            name: 'id',
            type: 'integer PRIMARY KEY AUTOINCREMENT'
        },{
            name: 'apttype',
            type: 'integer'
        },{
            name: 'aptdate',
            type: 'text'
        },{
            name: 'description',
            type: 'text'
        },{
            name: 'reminder0',
            type: 'integer'
        },{
            name: 'reminder1',
            type: 'integer'
        },{
            name: 'reminder7',
            type: 'integer'
        }]
        },{
        name : 'AgendaEvents',
        columns:[{
            name:'id',
            type:'integer PRIMARY KEY AUTOINCREMENT'
        },{
            name:'eventId',
            type:'integer'
        },{
            name:'appointmentId',
            type:'integer'
        },{
            name:'contactName',
            type:'text'
        },{
            name:'reminder8',
            type:'integer'
        }]
        },{
        name : 'Professional',
        columns:[{
            name:'id',
            type:'integer PRIMARY KEY AUTOINCREMENT'
        },{
            name:'title',
            type:'integer'
        },{
            name:'name',
            type:'text'
        },{
            name:'phone',
            type:'text'
        },{
            name:'cell',
            type:'text'
        },{
            name:'email',
            type:'text'
        },{
            name:'address',
            type:'text'
        },{
            name:'deviceId',
            type:'text'
        }]
        },{
        name : 'PatientGroup',
        columns:[{
            name:'id',
            type:'integer PRIMARY KEY AUTOINCREMENT'
        },{
            name:'builtin',
            type:'integer'
        },{
            name:'icon',
            type:'text'
        },{
            name:'name',
            type:'text'
        },{
            name:'description',
            type:'text'
        },{
            name:'address',
            type:'text'
        },{
            name:'phone',
            type:'text'
        },{
            name:'phoneExtra',
            type:'text'
        },{
            name:'cell',
            type:'text'
        },{
            name:'email',
            type:'text'
        },{
            name:'website',
            type:'text'
        }]
        },{
        name : 'HealthNetwork',
        columns:[{
            name:'id',
            type:'integer PRIMARY KEY AUTOINCREMENT'
        },{
            name:'location',
            type:'integer'
        },{
            name:'name',
            type:'text'
        },{
            name:'address',
            type:'text'
        },{
            name:'phone',
            type:'text'
        },{
            name:'phoneExtra',
            type:'text'
        },{
            name:'phone2',
            type:'text'
        },{
            name:'phone2Extra',
            type:'text'
        },{
            name:'fax',
            type:'text'
        },{
            name:'email',
            type:'text'
        },{
            name:'website',
            type:'text'
        },{
            name:'prophone',
            type:'text'
        },{
            name:'email2',
            type:'text'
        }]
        },{
        name : 'WebSite',
        columns:[{
            name:'id',
            type:'integer PRIMARY KEY AUTOINCREMENT'
        },{
            name:'builtin',
            type:'integer'
        },{
            name:'description',
            type:'text'
        },{
            name:'link',
            type:'text'
        }]
        },{
        name: 'Medicine',
        columns: [{
            name: 'doseUnit',
            type: 'numeric'
        },{
            name: 'id',
            type: 'integer PRIMARY KEY AUTOINCREMENT'
        },{
            name: 'type',
            type: 'integer'
        },{
            name: 'name',
            type: 'text'
        },{
            name: 'doseFrequency',
            type: 'integer'
        },{
            name: 'doseFrequencyUnit',
            type: 'integer'
        },{
            name: 'doseHour',
            type: 'text'
        },{
            name: 'doseMinute',
            type: 'text'
        },{
            name: 'lastDoseTakenDate',
            type: 'text'
        },{
            name: 'boxCapacity',
            type: 'integer'
        },{
            name: 'lastBoxOpenedDate',
            type: 'text'
        },{
            name: 'newBoxScheduledDate',
            type: 'text'
        },{
            name: 'doseTakenCount',
            type: 'integer'
        }]
        },{
        name : 'MedicineExt',
        columns:[{
            name:'id',
            type:'integer PRIMARY KEY AUTOINCREMENT'
        },{
            name:'medicineId',
            type:'integer'
        },{
            name:'medicineType',
            type:'integer'
        },{
            name:'durationType',
            type:'integer'
        },{
            name:'reminderMatin',
            type:'integer'
        },{
            name:'reminderMidi',
            type:'integer'
        },{
            name:'reminderSoir',
            type:'integer'
        },{
            name:'boiteNote',
            type:'text'
        },{
            name:'fileName',
            type:'text'
        },{
            name:'medicineIntake',
            type:'integer'
        },{
            name:'deleteNotifyFlag',
            type:'integer'
        },{
            name:'lastIgnoreDate',
            type:'text'
        },{
            name:'doseFrequencyUnitValue',
            type:'text'
        },{
            name:'durationValue',
            type:'text'
        },{
            name:'matinStatus',
            type:'text'
        },{
            name:'midiStatus',
            type:'text'
        },{
            name:'soirStatus',
            type:'text'
        },{
            name:'reminderOther',
            type:'text'
        },{
            name:'otherStatus',
            type:'text'
        },{
            name:'medicineStartDate',
            type:'text'
        }]
        },{
        name : 'PrepareMyConsultation',
        columns:[{
            name:'id',
            type:'integer PRIMARY KEY AUTOINCREMENT'
        },{
            name:'eventId',
            type:'integer'
        },{
            name:'consultationQuestions',
            type:'text'
        },{
            name:'consultationDocuments',
            type:'text'
        }]
        },{
        name : 'Question',
        columns:[{
            name:'id',
            type:'integer PRIMARY KEY AUTOINCREMENT'
        },{
            name:'description',
            type:'text'
        },{
            name:'checked',
            type:'integer'
        },{
            name:'builtin',
            type:'integer'
        }]
        },{
        name : 'Document',
        columns:[{
            name:'id',
            type:'integer PRIMARY KEY AUTOINCREMENT'
        },{
            name:'description',
            type:'text'
        },{
            name:'checked',
            type:'integer'
        },{
            name:'builtin',
            type:'integer'
        }]
    },{
        name : 'NotificationQ',
        columns:[{
            name:'id',
            type:'integer PRIMARY KEY AUTOINCREMENT'
        },{
            name:'perantId',
            type:'integer'
        },{
            name:'perantType',
            type:'text'
        },{
            name:'title',
            type:'text'
        },{
            name:'text',
            type:'text'
        },{
            name:'at',
            type:'text'
        },{
            name:'atInMinites',
            type:'integer'
        },{
            name:'nextAtInMinites',
            type:'integer'
        },{
            name:'intervalInMinites',
            type:'integer'
        },{
            name:'intervalType',
            type:'text'
        },{
            name:'isScheduled',
            type:'integer'
        },{
            name:'duree',
            type:'integer'
        }]
    }]
});   