angular.module('LocalNotification.services', []).service('notificationutil', function($ionicPlatform, $ionicPopup, $cordovaLocalNotification, $translate, treatmentService, $q, $filter, DB, $ionicLoading) {

    var self = this;

    // var self.Key_ActiveNotificationCount='ActiveNotificationCount';
    self.maxNotifyLimit=63;
    if (ionic.Platform.isAndroid()) {
       self.maxNotifyLimit=49;
       //console.log("@@@ LocalNotification.services Android self.maxNotifyLimit="+self.maxNotifyLimit);
    }else{
        //console.log("@@@ LocalNotification.services iOS self.maxNotifyLimit="+self.maxNotifyLimit);
    }
    
    self.getTimeingSettings = function() {
        var timeMorning = localStorage.getItem('matinTime');
        var timeNoon = localStorage.getItem('midiTime');
        var timeNight = localStorage.getItem('soirTime');

        timeMorning = timeMorning ? timeMorning : '08h00';
        timeNoon = timeNoon ? timeNoon : '12h00';
        timeNight = timeNight ? timeNight : '19h00';
        return [timeMorning, timeNoon, timeNight];
    };

    self.showLoader = function() {
        $ionicLoading.show({
          template: '<ion-spinner icon="spiral"></ion-spinner>'
        });
    };

    self.hideLoader = function(){
        setTimeout(function(){  
            $ionicLoading.hide();
        }, 1000);
    };
   
    self.addSingleNotification = function(recId, notifyDateTime, strMsg) {
        //console.log("Checking addSingleNotification recId=" +recId+",notifyDateTime="+ notifyDateTime+", strMsg="+ strMsg);

       /* if (ionic.Platform.isAndroid()) {
            var notifyId = "" + recId + "10";
            var objNotificationJSON = {
                id: notifyId,
                text: strMsg,
                title: $translate.instant("SEP_AGENDA"),
                at: notifyDateTime,
                sound: null
            };

            self.setLocalNotificationDevice(objNotificationJSON);

        } else {*/
            var maxScheduleLimit = self.maxNotifyLimit;
            //console.log("### addSingleNotification meditext strMsg="+strMsg);
                  var mediCyperText= aesUtil.encrypt(salt, iv, passPhrase, strMsg);
                  //var mediText=aesUtil.decrypt(salt, iv, passPhrase, mediCyperText);
                  //console.log("### addSingleNotification meditext -mediCyperText="+mediCyperText);
                
            var tempAtInMinites=Math.floor(notifyDateTime.getTime() / 60000); //convert to minits
            var message = {
                perantId: recId,
                perantType: "s", // treatment
                title: $translate.instant("SEP_AGENDA"),
                text: mediCyperText,
                at: notifyDateTime,
                atInMinites: tempAtInMinites,
                nextAtInMinites: 0,
                intervalInMinites: 0,
                isScheduled: 0,
                duree: 0
            };

            self.insertNotificationQ(message).then(function(result) {
                //console.log("insertNotification called successfully result=" + result);

                self.handleLocalNotificationIniOS(maxScheduleLimit);
            });
            /* var now = new Date().getTime();
             var _10SecondsFromNow = new Date(now + 10 * 1000);
             
             console.log(">> addNotification test input="+JSON.stringify(objNotificationJSON));  
             self.setLocalNotificationDevice(objNotificationJSON);*/
       // }
    };

    self.addAllNotification = function(treatmentObjList) {   
        self.showLoader();
        //console.log("Checking addAllNotification self.maxNotifyLimit="+self.maxNotifyLimit);
        //console.log("Checking addAllNotification input=" + JSON.stringify(treatmentObjList));
        if(treatmentObjList && treatmentObjList.length>0){
            var count=treatmentObjList.length;
              for(var i=0;i<count;i++){
                  var treatmentObj = treatmentObjList[i];
                  //notificationutil.addNotification(treatment);
                  self.createiOSNotification(treatmentObj, self.maxNotifyLimit);
              }
              self.handleLocalNotificationIniOS(self.maxNotifyLimit);
        } else{
            self.hideLoader();
        }
    }

    self.deleteAllNotification = function() {
        self.deleteAllNotificationQ().then(function(result){
                self.removeAllLocalNotificationDevice();
        }, function(error){
                self.removeAllLocalNotificationDevice();
        });
    }

    self.addNotification = function(treatmentObj) {
        self.showLoader();
        var maxScheduleLimit = self.maxNotifyLimit;
        //console.log("Checking addNotification input=" + JSON.stringify(treatmentObj));
       /* if (ionic.Platform.isAndroid()) {
            var intFrequency = parseInt(treatmentObj.doseFrequencyUnit);

            if (treatmentObj.durationType === 0 || treatmentObj.durationType === "0" ) {
                self.createiOSNotification(treatmentObj); //maxScheduleLimit based on duree
                self.handleLocalNotificationIniOS();
            } else if(intFrequency===3){//monthly
                self.createiOSNotification(treatmentObj, maxScheduleLimit); //maxScheduleLimit based on duree
                self.handleLocalNotificationIniOS(maxScheduleLimit);
            }else{
                self.createAndroidNotification(treatmentObj);
            }

        } else {*/
            
            self.createiOSNotification(treatmentObj, maxScheduleLimit); //maxScheduleLimit=self.maxNotifyLimit in ios
            self.handleLocalNotificationIniOS(maxScheduleLimit);
            /* var now = new Date().getTime();
             var _10SecondsFromNow = new Date(now + 10 * 1000);
             var objNotificationJSON={
                     id: treatmentObj.id,
                     text: treatmentObj.name,
                     title: "SEP_AGENDA",
                     at: _10SecondsFromNow,
                     sound: null
                 };
             console.log(">> addNotification test input="+JSON.stringify(objNotificationJSON));  
             self.setLocalNotificationDevice(objNotificationJSON);*/
       // }
    };
   

    self.deleteNotification = function(treatmentObj) {
        self.showLoader();
        //console.log("Checking deleteNotification input=" + JSON.stringify(treatmentObj));
       /* if (ionic.Platform.isAndroid()) {
            var intFrequency = parseInt(treatmentObj.doseFrequencyUnit);
            if (treatmentObj.durationType === 0 || treatmentObj.durationType === "0" || intFrequency===3) {
                //self.deleteiOSNotification(treatmentObj);
                self.deleteNotificationByPerantIdQ(treatmentObj.id).then(function(result){
                    self.handleLocalNotificationIniOS();
                }, function(error){
                    self.handleLocalNotificationIniOS();
                });
            } else {
                var messageIds = ["" + treatmentObj.id + 1, "" + treatmentObj.id + 2, "" + treatmentObj.id + 3];
                if (treatmentObj.reminderOther && treatmentObj.reminderOther !== "") {
                    var jsonObj = JSON.parse(treatmentObj.reminderOther);
                    var count = jsonObj.length;
                    for (var i = 0; i < count; i++) {
                        var cusTime = jsonObj[i];
                        var reminderOthersId = '' + treatmentObj.id + '4' + cusTime.id;
                        messageIds.push(reminderOthersId);
                    }
                }
                self.removeLocalNotificationDevice(messageIds);
            }
        } else {*/
            var maxScheduleLimit = self.maxNotifyLimit;
            //self.deleteiOSNotification(treatmentObj);
            self.deleteNotificationByPerantIdQ(treatmentObj.id).then(function(result){
                self.handleLocalNotificationIniOS(maxScheduleLimit);
            }, function(error){
                self.handleLocalNotificationIniOS(maxScheduleLimit);
            });
       // }
    };

    self.updateNotification = function(oldTreatmentObj, treatmentObj) {
        self.showLoader();
        //console.log("Checking updateNotification input old =" + JSON.stringify(oldTreatmentObj));
        //console.log("Checking updateNotification input new =" + JSON.stringify(treatmentObj));

     /*   if (ionic.Platform.isAndroid()) {
            //var messageIds=[""+treatmentObj.id+1, ""+treatmentObj.id+2, ""+treatmentObj.id+3];
             var intOldFrequency = parseInt(oldTreatmentObj.doseFrequencyUnit);
            if (oldTreatmentObj.durationType === 0 || oldTreatmentObj.durationType === "0" || intOldFrequency===3) {
                //self.deleteiOSNotification(oldTreatmentObj);
                self.deleteNotificationByPerantIdQ(oldTreatmentObj.id).then(function(result){
                    self.addNotification(treatmentObj);
                }, function(error){
                    self.addNotification(treatmentObj);
                });
            } else {
                self.deleteNotification(oldTreatmentObj);
                 self.addNotification(treatmentObj);
            }

           /*  var intNewFrequency = parseInt(treatmentObj.doseFrequencyUnit);
            if (treatmentObj.durationType === 0 || treatmentObj.durationType === "0" || intNewFrequency===3) {
                self.createiOSNotification(treatmentObj);
                self.handleLocalNotificationIniOS();
            } else {*/
               
            //}
        //} else {
            var maxScheduleLimit = self.maxNotifyLimit;
            //self.deleteiOSNotification(oldTreatmentObj);
            self.deleteNotificationByPerantIdQ(oldTreatmentObj.id).then(function(result){
                self.addNotification(treatmentObj);
            }, function(error){
                self.addNotification(treatmentObj);
            });
            
        //}
    };



    //=================================
    // iOS Platform specific function
    //=================================
    self.createiOSNotification = function(treatmentObj, maxScheduleLimit) {
        
        var TimeingList = self.getTimeingSettings();
        var timeMorning = TimeingList[0],
            timeNoon = TimeingList[1],
            timeNight = TimeingList[2];
        //console.log("createiOSNotification Settings timeMorning=" + timeMorning + " timeNoon=" + timeNoon + " timeNight=" + timeNight);

        var isChecked = 1;
        if (treatmentObj.reminderMatin === isChecked) {
            var reminderMatinId = '' + treatmentObj.id + '1';
            var matinNotificationJSON = self.prepareiOSNotificationJSON(reminderMatinId, treatmentObj, timeMorning);
            var mediTime=self.getTimeSlotText(1);
            var mealTime=self.getMealSlotText(treatmentObj['medicineIntake']);
            matinNotificationJSON['text']=self.getNotificationText(treatmentObj, mediTime, mealTime);
            self.setiOSLocalNotification(matinNotificationJSON, maxScheduleLimit);
        }

        if (treatmentObj.reminderMidi === isChecked) {
            var reminderMidiId = '' + treatmentObj.id + '2';
            var midiNotificationJSON = self.prepareiOSNotificationJSON(reminderMidiId, treatmentObj, timeNoon);
            var mediTime=self.getTimeSlotText(2);
            var mealTime=self.getMealSlotText(treatmentObj['medicineIntake']);
            midiNotificationJSON['text']=self.getNotificationText(treatmentObj, mediTime, mealTime);
            self.setiOSLocalNotification(midiNotificationJSON, maxScheduleLimit);
        }

        if (treatmentObj.reminderSoir === isChecked) {
            var reminderSoirId = '' + treatmentObj.id + '3';
            var soirNotificationJSON = self.prepareiOSNotificationJSON(reminderSoirId, treatmentObj, timeNight);
            var mediTime=self.getTimeSlotText(3);
            var mealTime=self.getMealSlotText(treatmentObj['medicineIntake']);
            soirNotificationJSON['text']=self.getNotificationText(treatmentObj, mediTime, mealTime);
            self.setiOSLocalNotification(soirNotificationJSON, maxScheduleLimit);
        }

        //"id\":1,\"value\":\"15 h 45\"
        //console.log("++ insert treatmentObj.reminderOther=" + treatmentObj.reminderOther);
        if (treatmentObj.reminderOther !== "") {
            var jsonObj = JSON.parse(treatmentObj.reminderOther);
            var count = jsonObj.length;
            for (var i = 0; i < count; i++) {
                var cusTime = jsonObj[i];
                var reminderOthersId = '' + treatmentObj.id + '4' + cusTime.id;

                var strtime = cusTime.value;
                var strtimeParts = strtime.split("h");
                var time = strtimeParts[0].trim() + "h" + strtimeParts[1].trim();

                var otherNotificationJSON = self.prepareiOSNotificationJSON(reminderOthersId, treatmentObj, time);
                var mealTime=self.getMealSlotText(treatmentObj['medicineIntake']);
                otherNotificationJSON['text']=self.getNotificationText(treatmentObj, strtime, "");
                self.setiOSLocalNotification(otherNotificationJSON, maxScheduleLimit);
            }
        }
    };

    self.setiOSLocalNotification = function(messageObj, maxScheduleLimit, callbackFunction) {
        var curDate = new Date();
        var curMints = curDate.getTime() / 60000; //convert to minits

        var everyMinits = parseInt(messageObj['intervalInMinites']);
        var durMinits = parseInt(messageObj['duree']);
        var actualCount = Math.floor(durMinits / everyMinits) + 1;
        var preScheduleMaxLimit = maxScheduleLimit ? maxScheduleLimit : actualCount;
        var atDate = new Date(messageObj.at);
        var atMints = Math.floor(atDate.getTime() / 60000); //convert to minits
        var nextAtMints = self.nextNotifiDateInMints(atMints, messageObj.intervalType, everyMinits);//atMints + everyMinits;
        var messageList=[];
        for (var i = 0; i < preScheduleMaxLimit; ) {
            //console.log("b4 insert atMints=" + atMints +" durMinits=" +durMinits+" atDate=" + atDate +" end date="+new Date(durMinits*60000));
            //check notify time exceed duration limit
            if (durMinits > 0 && durMinits < atMints) {
                break; // break loop
            } else {
                //console.log("###"+i + " setiOSLocalNotification meditext -messageObj.text="+messageObj.text);
                  var mediCyperText= aesUtil.encrypt(salt, iv, passPhrase, messageObj.text);
                  //var mediText=aesUtil.decrypt(salt, iv, passPhrase, mediCyperText);
                  //console.log("###"+i + " setiOSLocalNotification meditext -mediCyperText="+mediCyperText);
               
                var message = {
                    perantId: messageObj.perantId,
                    perantType: "T", // treatment
                    title: messageObj.title,
                    text: mediCyperText,
                    at: atDate,
                    atInMinites: atMints,
                    nextAtInMinites: nextAtMints,
                    intervalInMinites: everyMinits,
                    intervalType:messageObj.intervalType,
                    isScheduled: 0,
                    duree: durMinits
                };

                var msgRec="("+message.perantId+",'"+ 
                               message.perantType+"','"+  
                               message.title+"','"+  
                               message.text+"','"+  
                               message.at+"',"+  
                               message.atInMinites+","+  
                               message.nextAtInMinites+","+  
                               message.intervalInMinites+",'"+  
                               message.intervalType+"',"+  
                               message.isScheduled+","+  
                               message.duree+")";
                if (atMints >= curMints) {
                    i++;//LOOP INCREMENT
                    messageList.push(msgRec);
                   /* self.insertNotificationQ(message).then(function(result) {
                        console.log("insertNotification called successfully result=" + result);
                    });*/
                }
                atMints = parseInt(message.nextAtInMinites);
                atDate = new Date(atMints * 60000);
                nextAtMints=self.nextNotifiDateInMints(atMints, messageObj.intervalType, everyMinits);
                
                
            }
        }
        //console.log("##### insertNotification messageList="+JSON.stringify(messageList));
        if(messageList.length>0){
            self.insertBulkNotificationQ(messageList).then(function(result) {
            //console.log("insertNotification called successfully result=" + result);
         
            if(callbackFunction){
                callbackFunction(messageList);
            }
         });
        } else{
           self.hideLoader(); 
        }
    };

    self.nextNotifiDateInMints=function(fromDateInMints, intervalType, everyMinits){

        var nextAtMints=fromDateInMints;
         var treatmentDateTime = new Date(fromDateInMints * 60000);
        //console.log("Checking nextNotifiDateInMints b4 treatmentDateTime=" + treatmentDateTime + " intervalType=" + intervalType);

        if(intervalType==='3'){// every 1 month
            var scheduledDay=treatmentDateTime.getDate();
            do{
                //var msCurDateTime = treatmentDateTime.getTime();
                treatmentDateTime.setSeconds(0);
               // var msNotifyDateTime = treatmentDateTime.getTime();
                var curMonth = treatmentDateTime.getMonth();
                if (curMonth === 11) {
                    var cutYYYY = treatmentDateTime.getFullYear();
                    treatmentDateTime.setFullYear(cutYYYY + 1);
                    treatmentDateTime.setMonth(0);
                } else {
                    treatmentDateTime.setMonth(curMonth + 1);
                }
                treatmentDateTime.setDate(scheduledDay);
                var newday=treatmentDateTime.getDate();
                //console.log("Checking nextNotifiDateInMints treatmentDateTime="+treatmentDateTime+" newday="+newday+" scheduledDay="+scheduledDay);
            }while(newday!==scheduledDay);
            nextAtMints=Math.floor(treatmentDateTime.getTime() / 60000);
        }else{
            nextAtMints = nextAtMints + everyMinits;
        }
        //console.log("Checking nextNotifiDateInMints after nextAtMints=" + nextAtMints + " intervalType=" + intervalType+" treatmentDateTime="+treatmentDateTime);
      return nextAtMints;
    };

    self.deleteiOSNotification = function(treatmentObj) {
        //console.log("--B4 deleteiOSNotification");
        self.printNotificationQ();
        self.selectNotificationByPerantIdQ(treatmentObj.id).then(function(qResult) {
            var qCount = qResult.rows.length;
            for (var j = 0; j < qCount; j++) {
                var messageObj = qResult.rows.item(j);
                //console.log("--deleteiOSNotification messageObj=" + JSON.stringify(messageObj));
                self.removeLocalNotificationDevice(messageObj.id);
                self.deleteNotificationQ(messageObj.id).then(function(delResult) {
                    //self.removeLocalNotificationDevice(messageObj.id);//.then(function(success){
                    //console.log(messageObj.id + " cancelled in device, success");
                    //});
                }, function(error) {
                    console.log("deleteNotificationQ error=" + error);
                });
            }
        });
    };

    self.prepareiOSNotificationJSON = function(treatmentid, treatmentObj, treatmentTime) {
        var apptitle = "SEP_AGENDA";
        var objNotificationJSON = {
            perantId: treatmentObj.id,
            //date: _5_sec_from_now,
            text: treatmentObj.name,
            title: $translate.instant(apptitle),
            duree: 0//, //if 0 infinite
            //sound: null
        };

        if (treatmentObj.durationType === 0 || treatmentObj.durationType === "0") { //  is short trem
            var durValList = treatmentObj.durationValue.split(",");

            var intervelInt=parseInt(durValList[0]), intUnit = parseInt(durValList[1]);
            var durValMints = self.calculateNotifyIntervalMints(intervelInt, intUnit);

            var mediStartDate=new Date(treatmentObj.medicineStartDate);
            var mediStartDateInMints=Math.floor(mediStartDate.getTime() / 60000);
            var end =mediStartDateInMints+durValMints;
            objNotificationJSON['duree'] = end;
            //console.log("medi start "+mediStartDate+" end="+new Date(end*60000)+ " end in minute="+end); objNotificationJSON['duree'] = mediStartDateInMints+durValMints;
        }

        var intFrequency = parseInt(treatmentObj.doseFrequencyUnit);
        intFrequency = intFrequency ? intFrequency : 1;
        //var txtFrequency="day"; //second, minute, hour, day, week, month or year
        //1 - Daily 2 - Weekly 3 - Monthly 4 - Every
        switch (intFrequency) {
            case 1://Daily
                objNotificationJSON['intervalInMinites'] = self.calculateNotifyIntervalMints(1, intFrequency);
                objNotificationJSON['intervalType']='1';
                objNotificationJSON['at'] = self.calculateDailyDate(treatmentObj, treatmentTime);
                break;
            case 2://weekly
                objNotificationJSON['intervalInMinites'] = self.calculateNotifyIntervalMints(1, intFrequency);
                objNotificationJSON['intervalType']='2';
                objNotificationJSON['at'] = self.calculateWeeklyDate(treatmentObj, treatmentTime);
                break;
            case 3://monthly
                objNotificationJSON['intervalInMinites'] = self.calculateNotifyIntervalMints(1, intFrequency);
                objNotificationJSON['intervalType']='3';
                objNotificationJSON['at'] = self.calculateMonthlyDate(treatmentObj, treatmentTime);
                break;
            default:
                // every
                var userOpt = treatmentObj.doseFrequencyUnitValue.split(",");
                var intInterval = parseInt(userOpt[0]),
                    intUnit = parseInt(userOpt[1]);
                //console.log("Checking prepareNotificationJSON treatmentObj.doseFrequencyUnitValue=" + treatmentObj.doseFrequencyUnitValue);
                objNotificationJSON['intervalInMinites'] = self.calculateNotifyIntervalMints(intInterval, intUnit); //14*24*60;
                objNotificationJSON['intervalType']='4';
                objNotificationJSON['at'] = self.calculateDailyDate(treatmentObj, treatmentTime);
                break;
        }
        //console.log("Checking prepareNotificationJSON output=" + JSON.stringify(objNotificationJSON));
        return objNotificationJSON;
    };


    //==========================
    //Android specific function
    //==========================
    self.createAndroidNotification = function(treatmentObj) {
        
        var TimeingList = self.getTimeingSettings();
        var timeMorning = TimeingList[0],
            timeNoon = TimeingList[1],
            timeNight = TimeingList[2];
        //console.log("createAndroidNotification Settings timeMorning=" + timeMorning + " timeNoon=" + timeNoon + " timeNight=" + timeNight);

        var isChecked = 1;
        if (treatmentObj.reminderMatin === isChecked) {
            var reminderMatinId = '' + treatmentObj.id + '1';
            var matinNotificationJSON = self.prepareAndroidNotificationJSON(reminderMatinId, treatmentObj, timeMorning);
            var mediTime=self.getTimeSlotText(1);
            var mealTime=self.getMealSlotText(treatmentObj['medicineIntake']);
            matinNotificationJSON['text']=self.getNotificationText(treatmentObj, mediTime, mealTime);
            self.setLocalNotificationDevice(matinNotificationJSON);
        }

        if (treatmentObj.reminderMidi === isChecked) {
            var reminderMidiId = '' + treatmentObj.id + '2';
            var midiNotificationJSON = self.prepareAndroidNotificationJSON(reminderMidiId, treatmentObj, timeNoon);
            var mediTime=self.getTimeSlotText(2);
            var mealTime=self.getMealSlotText(treatmentObj['medicineIntake']);
            midiNotificationJSON['text']=self.getNotificationText(treatmentObj, mediTime, mealTime);
            self.setLocalNotificationDevice(midiNotificationJSON);
        }

        if (treatmentObj.reminderSoir === isChecked) {
            var reminderSoirId = '' + treatmentObj.id + '3';
            var soirNotificationJSON = self.prepareAndroidNotificationJSON(reminderSoirId, treatmentObj, timeNight);
            var mediTime=self.getTimeSlotText(3);
            var mealTime=self.getMealSlotText(treatmentObj['medicineIntake']);
            soirNotificationJSON['text']=self.getNotificationText(treatmentObj, mediTime, mealTime);
            self.setLocalNotificationDevice(soirNotificationJSON);
        }
        //"id\":1,\"value\":\"15 h 45\"
        if (treatmentObj.reminderOther && treatmentObj.reminderOther !== "") {
            var jsonObj = JSON.parse(treatmentObj.reminderOther);
            var count = jsonObj.length;
            for (var i = 0; i < count; i++) {
                var cusTime = jsonObj[i];
                var reminderOthersId = '' + treatmentObj.id + '4' + cusTime.id;

                var strtime = cusTime.value;
                var strtimeParts = strtime.split("h")
                var time = strtimeParts[0].trim() + "h" + strtimeParts[1].trim();

                var otherNotificationJSON = self.prepareAndroidNotificationJSON(reminderOthersId, treatmentObj, time);
                otherNotificationJSON['text']=self.getNotificationText(treatmentObj, strtime, "");
                self.setLocalNotificationDevice(otherNotificationJSON);
            };
        }
    };

    self.prepareAndroidNotificationJSON = function(treatmentid, treatmentObj, treatmentTime) {
        var apptitle = "SEP_AGENDA"
        var objNotificationJSON = {
            id: treatmentid,
            //date: _5_sec_from_now,
            text: treatmentObj.name,
            title: $translate.instant(apptitle),
            duree: 0
           // sound: null
        };

        if (treatmentObj.durationType === 0 || treatmentObj.durationType === "0") { //  is short trem
            var durValList = treatmentObj.durationValue.split(",");

             var intervelInt=parseInt(durValList[0]), intUnit = parseInt(durValList[1]);
            var durValMints = self.calculateNotifyIntervalMints(intervelInt, intUnit);

            var mediStartDate=new Date(treatmentObj.medicineStartDate);
            var mediStartDateInMints=Math.floor(mediStartDate.getTime() / 60000);
            var end =mediStartDateInMints+durValMints;
            objNotificationJSON['duree'] = end;
        //console.log("medi start "+mediStartDate+" end="+new Date(end*60000)+ " end in minute="+end);

        }

        var intFrequency = parseInt(treatmentObj.doseFrequencyUnit);
        //var txtFrequency="day"; //second, minute, hour, day, week, month or year
        //1 - Daily 2 - Weekly 3 - Monthly 4 - Every
        switch (intFrequency) {
            case 1:
                objNotificationJSON['every'] = "day"; //self.calculateNotifyIntervalMints(1, intFrequency);
                objNotificationJSON['at'] = self.calculateDailyDate(treatmentObj, treatmentTime);
                break;
            case 2:
                objNotificationJSON['every'] = "week"; //self.calculateNotifyIntervalMints(1, intFrequency);
                objNotificationJSON['at'] = self.calculateWeeklyDate(treatmentObj, treatmentTime);
                break;
            case 3:
                objNotificationJSON['every'] = "month"; //self.calculateNotifyIntervalMints(1, intFrequency);
                objNotificationJSON['at'] = self.calculateMonthlyDate(treatmentObj, treatmentTime);
                break;
            default:
                // every
                var userOpt = treatmentObj.doseFrequencyUnitValue.split(",");
                var intInterval = parseInt(userOpt[0]),
                    intUnit = parseInt(userOpt[1]);
                //console.log("Checking prepareNotificationJSON treatmentObj.doseFrequencyUnitValue=" + treatmentObj.doseFrequencyUnitValue);
                objNotificationJSON['every'] = self.calculateNotifyIntervalMints(intInterval, intUnit); //14*24*60;
                objNotificationJSON['at'] = self.calculateDailyDate(treatmentObj, treatmentTime);
                break;
        }
        //console.log("Checking prepareNotificationJSON output=" + JSON.stringify(objNotificationJSON));
        return objNotificationJSON;
    };


    // Common date calculation functions 
    self.getTimeSlotText=function(timeSlotIndex){
        var treatmentTimingList=[$translate.instant('MATIN').toLowerCase(),$translate.instant('MIDI').toLowerCase(),$translate.instant('SOIR').toLowerCase()];
        //console.log("getTimeSlotText timeSlotIndex="+timeSlotIndex+" treatmentTimingList="+JSON.stringify(treatmentTimingList));
        return treatmentTimingList[timeSlotIndex-1];
    } 
    self.getMealSlotText=function(mealTimeIndex){
        var treatmentFoodTimingList=[$translate.instant('AVANT_LE_REPAS').toLowerCase(),$translate.instant('PENDANT_LE_REPAS').toLowerCase(),$translate.instant('APRES_LE_REPAS').toLowerCase()];
        //console.log("getMealSlotText mealTimeIndex="+mealTimeIndex+" treatmentFoodTimingList="+JSON.stringify(treatmentFoodTimingList));
        return treatmentFoodTimingList[mealTimeIndex-1];
    } 

    self.getNotificationText=function(treatmentObj, timeslot, mealTime ){

       /*  var treatmentDosageList = [
            {listId: "1", listType:"tablet",  listName: $translate.instant('TREATMENTS_LIST_ITEM1')},
            {listId: "2", listType:"effervescent",  listName: $translate.instant('TREATMENTS_LIST_ITEM2')},
            {listId: "3", listType:"capsule", listName: $translate.instant('TREATMENTS_LIST_ITEM3')},
            {listId: "4", listType:"granules",  listName: $translate.instant('TREATMENTS_LIST_ITEM4')},
            {listId: "5", listType:"syrup",  listName: $translate.instant('TREATMENTS_LIST_ITEM5')},
            {listId: "6", listType:"oinment",  listName: $translate.instant('TREATMENTS_LIST_ITEM6')},
            {listId: "7", listType:"patch",  listName: $translate.instant('TREATMENTS_LIST_ITEM7')},
            {listId: "8", listType:"injection",  listName: $translate.instant('TREATMENTS_LIST_ITEM8')},
            {listId: "9", listType:"inhalation", listName: $translate.instant('TREATMENTS_LIST_ITEM9')},
            {listId: "10", listType:"suppository", listName: $translate.instant('TREATMENTS_LIST_ITEM10')},
            {listId: "11", listType:"bulb", listName: $translate.instant('TREATMENTS_LIST_ITEM11')},
            {listId: "12", listType:"drops", listName: $translate.instant('TREATMENTS_LIST_ITEM12')}
        ];
        var medicineTypeName = "";

        if(treatmentObj.medicineType != undefined && treatmentObj.medicineType != null && treatmentObj.medicineType != ""){
            medicineTypeName = treatmentDosageList[treatmentObj.medicineType-1].listName
        }
        console.log("Medicine Type name:"+medicineTypeName);
        var strText= $translate.instant('ADD_TREATMENTS_TAB_1')
            +" "+treatmentObj.name
            +"\n"+treatmentObj.doseUnit 
            +" "+medicineTypeName+"(s)"
            +" "+$translate.instant('THE')
            +" "+timeslot
            +" "+mealTime;
    */
        var strText=$translate.instant('SEPA_NOTIFICATION_PRE_MSG') +" "+treatmentObj.name;
        return strText;    
    };

    self.getMediStartDate=function(treatmentObj){
        //console.log("Checking getMediStartDate Before treatmentObj.medicineStartDate=" +treatmentObj.medicineStartDate);
        
        var curDate=new Date();
        curDate.setSeconds(0);
        var curTimeinMs=curDate.getTime();

        var mediStartDate=new Date(treatmentObj.medicineStartDate);
        mediStartDate.setHours(0);//curDate.getHours());
        mediStartDate.setMinutes(0);//curDate.getMinutes());
        mediStartDate.setSeconds(0);
        var mediStartDateInMs=mediStartDate.getTime();

        //console.log("Checking getMediStartDate curDate="+curDate+" mediStartDate="+mediStartDate);
        
        //console.log("Checking getMediStartDate curTimeinMs="+curTimeinMs+" mediStartDateInMs="+mediStartDateInMs);
       /* if(curTimeinMs>mediStartDateInMs){

            var intFrequency = parseInt(treatmentObj.doseFrequencyUnit);
            intFrequency = intFrequency ? intFrequency : 1;

            if(intFrequency===4){
                console.log("Checking getMediStartDate treatmentObj.doseFrequencyUnitValue=" + treatmentObj.doseFrequencyUnitValue);
                var userOpt = treatmentObj.doseFrequencyUnitValue.split(",");
                var intInterval = parseInt(userOpt[0]);
                intFrequency = parseInt(userOpt[1]);
            }else{
                intInterval=1;
            }

            var everyMinits=self.calculateNotifyIntervalMints(intInterval, intFrequency); 
           
            // mediStartDate=curTimeinMinits<mediStartDateInMints?mediStartDate:curDate;
            var mediStartDateInMints=Math.floor(mediStartDateInMs/60000);
            while(curTimeinMs>mediStartDateInMs){
               mediStartDateInMints= self.nextNotifiDateInMints(mediStartDateInMints, intFrequency, everyMinits);
               mediStartDateInMs=mediStartDateInMints*60000;
            }
        }
        mediStartDate=new Date(mediStartDateInMs);*/
        //console.log("Checking getMediStartDate After mediStartDate=" +mediStartDate);
        
        return mediStartDate;
    };

    self.calculateDailyDate = function(treatmentObj, treatmentTime) {
        var perDayinMS = 24 * 60 * 60 * 1000;

        var treatmentTimeHHMM = treatmentTime.split("h");
        var intTreatmentTimeHH = parseInt(treatmentTimeHHMM[0]);
        var intTreatmentTimeMM = parseInt(treatmentTimeHHMM[1]);
        //console.log("Checking calculateDailyDate intTreatmentTimeHH=" + intTreatmentTimeHH + " intTreatmentTimeMM=" + intTreatmentTimeMM);

        var treatmentDateTime = self.getMediStartDate(treatmentObj);//new Date(); //now
        var msfirstMorningDateTime = treatmentDateTime.getTime();
        //console.log("Checking calculateDailyDate b4 treatmentDateTime=" + treatmentDateTime);

        treatmentDateTime.setHours(intTreatmentTimeHH);
        treatmentDateTime.setMinutes(intTreatmentTimeMM);
        treatmentDateTime.setSeconds(0);

        var msSchuldedDateTime = treatmentDateTime.getTime();
        //var curHH=treatmentDateTime.getHours();
        //var curMM=treatmentDateTime.getMinutes();
        //var curDay=treatmentDateTime.getDay();

        //console.log("Checking calculateDailyDate b4 msfirstMorningDateTime=" + msfirstMorningDateTime);

        if (msSchuldedDateTime < msfirstMorningDateTime) {
            //treatmentDateTime.setDay(curDay+1);
            msSchuldedDateTime = msSchuldedDateTime + perDayinMS;
            treatmentDateTime.setTime(msSchuldedDateTime);
            //console.log("Checking calculateDailyDate a4 msSchuldedDateTime=" + msSchuldedDateTime + " treatmentDateTime=" + treatmentDateTime);
        }

        //console.log("Checking calculateDailyDate after treatmentDateTime=" + treatmentDateTime + " treatmentTime=" + treatmentTime);
        return treatmentDateTime;
    };


    self.calculateWeeklyDate = function(treatmentObj, treatmentTime) {
        var perDayinMS = 24 * 60 * 60 * 1000;
        var treatmentTimeHHMM = treatmentTime.split("h");

        var treatmentDateTime = self.getMediStartDate(treatmentObj);//new Date(); //now
        var intTreatmentTimeHH = parseInt(treatmentTimeHHMM[0]);
        var intTreatmentTimeMM = parseInt(treatmentTimeHHMM[1]);

        //console.log("Checking calculateWeeklyDate b4 treatmentDateTime=" + treatmentDateTime + " treatmentTime=" + treatmentTime);

        var curDay = treatmentDateTime.getDay();

        var scheduledDay = treatmentObj.doseFrequencyUnitValue !== null ? treatmentObj.doseFrequencyUnitValue : 1;
        //console.log("Checking calculateWeeklyDate b4 curDay=" + curDay + " scheduledDay=" + scheduledDay);

        scheduledDay = parseInt(scheduledDay) ;//- 1; // convert day index strats from 0 to 6
        var adddays = 0;
        if (curDay > scheduledDay) {
            adddays = ((7 - curDay) + scheduledDay);
        } else if (curDay < scheduledDay) {
            adddays = scheduledDay - curDay;
        }
        //console.log("Checking calculateWeeklyDate b4 adddays=" +adddays);
        var msfirstMorningDateTime = treatmentDateTime.getTime();
        msfirstMorningDateTime = msfirstMorningDateTime + (adddays * perDayinMS);

        treatmentDateTime.setTime(msfirstMorningDateTime);
        treatmentDateTime.setHours(intTreatmentTimeHH);
        treatmentDateTime.setMinutes(intTreatmentTimeMM);
        treatmentDateTime.setSeconds(0);
        //console.log("Checking calculateWeeklyDate after treatmentDateTime=" + treatmentDateTime + " treatmentTime=" + treatmentTime);
        return treatmentDateTime;
    };

    self.calculateMonthlyDate = function(treatmentObj, treatmentTime) {
        var treatmentTimeHHMM = treatmentTime.split("h");
        var intTreatmentTimeHH = parseInt(treatmentTimeHHMM[0]);
        var intTreatmentTimeMM = parseInt(treatmentTimeHHMM[1]);
        var scheduledDay = treatmentObj.doseFrequencyUnitValue !== null ? treatmentObj.doseFrequencyUnitValue : 1;
        scheduledDay=parseInt(scheduledDay);
        var treatmentDateTime =self.getMediStartDate(treatmentObj);//new Date(); //now
        var msCurDateTime = treatmentDateTime.getTime();
        do{
            //console.log("Checking calculateMonthlyDate b4 treatmentDateTime=" + treatmentDateTime + " treatmentTime=" + treatmentTime);
            var curMonth=treatmentDateTime.getMonth();

            treatmentDateTime.setDate(scheduledDay);
            treatmentDateTime.setHours(intTreatmentTimeHH);
            treatmentDateTime.setMinutes(intTreatmentTimeMM);
            treatmentDateTime.setSeconds(0);

            var updatedDateMonth=treatmentDateTime.getMonth();
            var msNotifyDateTime = treatmentDateTime.getTime();
            var newday=treatmentDateTime.getDate();

            if (msCurDateTime > msNotifyDateTime || (newday!==scheduledDay && curMonth===updatedDateMonth) ) {
                var curMonth = treatmentDateTime.getMonth();
                if (curMonth === 11) {
                    var cutYYYY = treatmentDateTime.getFullYear();
                    treatmentDateTime.setFullYear(cutYYYY + 1);
                    treatmentDateTime.setMonth(0);
                } else {
                    treatmentDateTime.setMonth(curMonth + 1);
                }
            }
            newday=treatmentDateTime.getDate();
            //console.log("Checking calculateMonthlyDate endloop treatmentDateTime=" + treatmentDateTime + " newday=" + newday+"==scheduledDay="+scheduledDay);
        }while(newday!==scheduledDay);

        //console.log("Checking calculateMonthlyDate after treatmentDateTime=" + treatmentDateTime + " treatmentTime=" + treatmentTime);
        return treatmentDateTime;
    };

    self.calculateNotifyIntervalMints = function(intInterval, intUnit) {
        var intUnitToDays = 1;
        switch (intUnit) {
            case 1:
                intUnitToDays = intInterval; //days
                break;
            case 2:
                intUnitToDays = intInterval * 7; //weeks
                break;
            case 3:
                intUnitToDays = intInterval * 30; //months
                break;
            default:
                intUnitToDays = intInterval; //days
                break;
        }
        var intervalMints = intUnitToDays * 1440; // convert days to mints
        //console.log("Checking calculateNotifyIntervalMints intInterval="+ intInterval+" , intUnit="+intUnit+ " intervalMints="+intervalMints +"  intUnitToDays="+intUnitToDays);
        return intervalMints;
    };

    //====================================================
    // Device Local notivication plugin caller functin
    //====================================================
    self.setLocalNotificationDevice = function(messageObj) {
        messageObj['icon']= "res://icon.png";
        $cordovaLocalNotification.add(messageObj).then(function(result) {
            //console.log("setLocalNotificationDevice done : " + JSON.stringify(messageObj) + "  result=" + result);
        });
        //console.log("setLocalNotification called");
    };

    self.retsetLocalNotificationDevice = function(message) {
        $cordovaLocalNotification.update(message).then(function(result) {
            //console.log("The notification has been reset");
        });
        //console.log("setLocalNotification called");
    };

    self.removeLocalNotificationDevice = function(messageIds) {
        $cordovaLocalNotification.cancel(messageIds).then(function(result) {
            //console.log("The notification has been removed result=" + result + " messageIds=" + messageIds);
        });
        //console.log("removeLocalNotification called");
    };

    self.removeAllLocalNotificationDevice = function() {
        $cordovaLocalNotification.cancelAll().then(function(result) {
            //console.log("All notification has been Removed, self.printScheduledIdsInDevice="+self.printScheduledIdsInDevice());
        });
        //console.log("removeAllLocalNotification called");
    };

    self.printScheduledIdsInDevice = function() {
            /*$cordovaLocalNotification.getScheduledIds().then(function(result) {
                //console.log("### " + result.length + " - ScheduledIds " + JSON.stringify(result));
            }, function(error) {
                //console.log("### fetched from device error:" + JSON.stringify(error));
            });*/
    }
    //====================================================
    //DB logic
    //====================================================
    self.insertNotificationQ = function(notificationQObj) {
        //console.log("insertNotificationQ notificationQObj = " + JSON.stringify(notificationQObj));
        var sqlQuery = 'insert or replace into NotificationQ(perantId,perantType,title,text,at,atInMinites,nextAtInMinites,intervalInMinites, intervalType, isScheduled, duree) values (?,?,?,?,?,?,?,?,?,?, ?)';
        var bindingvalues = [notificationQObj.perantId, notificationQObj.perantType, notificationQObj.title, notificationQObj.text, notificationQObj.at, notificationQObj.atInMinites, notificationQObj.nextAtInMinites, notificationQObj.intervalInMinites, notificationQObj.intervalType, notificationQObj.isScheduled, notificationQObj.duree];
        return DB.query(sqlQuery, bindingvalues).then(function(result) {
            //console.log("successfully inserted into NotificationQ with ID : " + result.insertId);
            return result;
        }, function(error) {
            console.log("Error inserting into NotificationQ");
            return error;
        });
    };

    self.insertBulkNotificationQ = function(notificationQObj) {
        //console.log("insertBulkNotificationQ notificationQObj = " + JSON.stringify(notificationQObj));
        //var sqlQuery = 'insert or replace into NotificationQ(perantId,perantType,title,text,at,atInMinites,nextAtInMinites,intervalInMinites, intervalType, isScheduled, duree) values (?,?,?,?,?,?,?,?,?,?, ?)';
        var sqlQuery = 'insert or replace into NotificationQ(perantId,perantType,title,text,at,atInMinites,nextAtInMinites,intervalInMinites, intervalType, isScheduled, duree) values '+notificationQObj.join(",");
        //var bindingvalues = [notificationQObj.perantId, notificationQObj.perantType, notificationQObj.title, notificationQObj.text, notificationQObj.at, notificationQObj.atInMinites, notificationQObj.nextAtInMinites, notificationQObj.intervalInMinites, notificationQObj.intervalType, notificationQObj.isScheduled, notificationQObj.duree];
        //console.log("SQLQUERYINSERTBULK:"+sqlQuery);
        return DB.query(sqlQuery).then(function(result) {
            //console.log("successfully inserted into insertBulkNotificationQ with ID : " + result.insertId);
            return result;
        }, function(error) {
            console.log("Error inserting into insertBulkNotificationQ");
            return error;
        });
    };

    /*self.updateNotificationQ = function(notificationQObj){
        var sqlQuery = 'update NotificationQ set perantId=?,perantType=?,title=?,text=?,at=?,atInMinites=?,nextAtInMinites=?,intervalInMinites=?,isScheduled=?, duree=? where id = ?';
        var bindingvalues = [notificationQObj.perantId,notificationQObj.perantType,notificationQObj.title,notificationQObj.text,notificationQObj.at,notificationQObj.atInMinites,notificationQObj.nextAtInMinites,notificationQObj.intervalInMinites,notificationQObj.isScheduled, notificationQObj.duree, notificationQObj.id];
        return DB.query(sqlQuery,bindingvalues).then(function(result){
            return result;
        },function(error){
            return error;
        });
    };*/

    self.deleteNotificationQ = function(notificationQObjId) {
        var sqlQuery = 'delete from NotificationQ where id=?';
        var bindingvalues = [notificationQObjId];
        return DB.query(sqlQuery, bindingvalues).then(function(result) {
            return result;
        }, function(error) {
            return error;
        });
    };

    self.selectNotificationQ = function() {
        //var sqlQuery = "select id, perantId,perantType,title,text,at,atInMinites,nextAtInMinites,intervalInMinites,isScheduled from NotificationQ where perantId==? ORDER BY atInMinites ASC";
        var sqlQuery = "select * from NotificationQ ORDER BY atInMinites ASC";
        var bindingvalues = [perantId];
        return DB.query(sqlQuery).then(function(result) {
            //console.log("selectNotificationQ data recieved : " + result.rows.length);
            return result;
        }, function(error) {
            console.log("Error reading selectNotificationQ Data : " + error);
            return error
        });
    }

    self.selectNotificationByPerantIdQ = function(perantId) {
        //var sqlQuery = "select id, perantId,perantType,title,text,at,atInMinites,nextAtInMinites,intervalInMinites,isScheduled from NotificationQ where perantId==? ORDER BY atInMinites ASC";
        var sqlQuery = "select * from NotificationQ where perantId==? ORDER BY atInMinites ASC";
        var bindingvalues = [perantId];
        return DB.query(sqlQuery, bindingvalues).then(function(result) {
            //console.log("selectNotificationByPerantIdQ data recieved : " + result.rows.length);
            return result;
        }, function(error) {
            console.log("Error reading selectNotificationByPerantIdQ Data : " + error);
            return error
        });
    }

    self.deleteNotificationByPerantIdQ = function(perantId) {
        //var sqlQuery = "select id, perantId,perantType,title,text,at,atInMinites,nextAtInMinites,intervalInMinites,isScheduled from NotificationQ where perantId==? ORDER BY atInMinites ASC";
        var sqlQuery = 'delete from NotificationQ where perantId==?';
        var bindingvalues = [perantId];
        return DB.query(sqlQuery, bindingvalues).then(function(result) {
            //console.log("deleteNotificationByPerantIdQ data recieved : " + result.rows.length);
            return result;
        }, function(error) {
            console.log("Error reading deleteNotificationByPerantIdQ Data : " + error);
            return error
        });
    }

    self.deleteAllNotificationQ = function() {
        //var sqlQuery = "select id, perantId,perantType,title,text,at,atInMinites,nextAtInMinites,intervalInMinites,isScheduled from NotificationQ where perantId==? ORDER BY atInMinites ASC";
        var sqlQuery = 'delete from NotificationQ';
        return DB.query(sqlQuery).then(function(result) {
            //console.log("deleteAllNotificationQ data recieved : " + result.rows.length);
            return result;
        }, function(error) {
            console.log("Error reading deleteAllNotificationQ Data : " + error);
            return error
        });
    }


    //reschedule notification
    self.resetNotificationQ = function() {
        // id, durationType, durationValue
       
        treatmentService.selectAllTreatmentMedicines().then(function(result) {
            var treatmentCount = result.rows.length;
            //console.log("resetNotificationQ::treatmentService.selectAllTreatmentMedicines treatmentCount=" + treatmentCount);
            if (treatmentCount > 0) {
                 self.showLoader();
                for (var i = 0; i < treatmentCount; i++) {
                    var treatmentObj = result.rows.item(i);
                    var isChecked = 1,
                        timeingCount = 0;

                    timeingCount = treatmentObj.reminderMatin === isChecked ? (timeingCount + 1) : timeingCount;
                    timeingCount = treatmentObj.reminderMidi === isChecked ? (timeingCount + 1) : timeingCount;
                    timeingCount = treatmentObj.reminderSoir === isChecked ? (timeingCount + 1) : timeingCount;

                    if (treatmentObj.reminderOther && treatmentObj.reminderOther !== "") {
                        var jsonObj = JSON.parse(treatmentObj.reminderOther);
                        timeingCount = timeingCount + jsonObj.length;
                    }

                    if (timeingCount > 0) {
                        self.selectReneuableNotificationQ(treatmentObj.id, timeingCount).then(function(qResult) {
                            var qCount = qResult.rows.length;
                            var iOS_MaxNotifyLimit = self.maxNotifyLimit;
                            for (var j = 0; j < qCount; j++) {

                                var messageObj = qResult.rows.item(j);
                                //console.log(JSON.stringify(messageObj));
                                var everyMinits = parseInt(messageObj.intervalInMinites);
                                var durMinits = parseInt(messageObj.duree);

                                var atDate = new Date(messageObj.at);
                                var atMints = Math.floor(atDate.getTime() / 60000); //convert to minits
                                
                                atMints = self.nextNotifiDateInMints(atMints, messageObj.intervalType, everyMinits);//atMints + everyMinits;atMints + everyMinits;
                                
                                var ms = atMints * 60000;
                                atDate = new Date(ms);

                                var nextAtMints =self.nextNotifiDateInMints(atMints, messageObj.intervalType, everyMinits);// atMints + everyMinits;

                                var curDate = new Date();
                                var curTimeinMinits = Math.floor(curDate.getTime() / 60000);
                                var diffMinits = atMints - curTimeinMinits;
                                
                                //console.log("###"+j + " resetNotificationQ meditext -cypertext="+messageObj.text);
                                var mediText=aesUtil.decrypt(salt, iv, passPhrase, messageObj.text);
                                //console.log("###"+j + " resetNotificationQ meditext -mediText="+mediText);
                    
                                var message = {
                                    perantId: messageObj.perantId,
                                    perantType: "T", // treatment
                                    title: messageObj.title,
                                    text: mediText,
                                    at: atDate,
                                    atInMinites: atMints,
                                    nextAtInMinites: nextAtMints,
                                    intervalInMinites: everyMinits,
                                    intervalType:messageObj.intervalType,
                                    isScheduled: 0,
                                    duree: durMinits
                                };
                                self.setiOSLocalNotification(message, iOS_MaxNotifyLimit , function(msgList){
                                    //console.log("resetNotificationQ::msgList="+JSON.stringify(msgList));
                                     self.handleLocalNotificationIniOS(iOS_MaxNotifyLimit);
                                });
                               /* if (diffMinits < 0) {
                                    messageObj.at = atDate;
                                    messageObj.atInMinites = atMints;
                                    messageObj.nextAtInMinites = nextAtMints;
                                    self.setiOSLocalNotification(messageObj);
                                } else {
                                    var countUpNotify = diffMinits / everyMinits;
                                    if (countUpNotify < iOS_MaxNotifyLimit) {
                                        messageObj.at = atDate;
                                        messageObj.atInMinites = atMints;
                                        messageObj.nextAtInMinites = nextAtMints;
                                        self.setiOSLocalNotification(messageObj);
                                    }
                                } */// end if else
                            } //end for
                        });
                    } else{
                        self.hideLoader();
                    } // end if
                } //end for
            } //end if
           
        }, function(error) {
            console.log("resetNotificationQ::treatmentService.selectAllTreatmentMedicines error=" + error);
        });
    };

    self.handleLocalNotificationIniOS = function(maxScheduleLimit) {
        var nowdate = new Date();
        var nowInMinits = Math.floor(nowdate.getTime() / 60000); // convert ms to mints
        //console.log("## Before ex-notify del and re-schedule up coming notifcation nowInMinits=" + nowInMinits + " nowdate=" + nowdate);
        /* self.selectExNotificationQ(nowInMinits).then(function(result){
             var exNotifyCount = result.rows.length;
             if(exNotifyCount>0){
                 for(var i=0;i<exNotifyCount;i++){
                     var notificationTimeObj=result.rows.item(i);
                     console.log(i+" selectExNotification nowInMinits="+nowInMinits+"  notificationTimeObj="+JSON.stringify(notificationTimeObj));
                     //notificationTimeObj.atInMinites=notificationTimeObj.atInMinites+notificationTimeObj.intervalInMinites;
                     //notificationTimeObj.at=new Date(notificationTimeObj.atInMinites);
                     //notificationTimeObj.isScheduled=0;
                     self.deleteNotificationQ(notificationTimeObj).then(function(result){
                         console.log("deleteNotification result="+result);
                         self.removeLocalNotificationDevice(notificationTimeObj.id).then(function(result){
                             console.log("removeLocalNotification notificationTimeObj="+JSON.stringify(notificationTimeObj));
                         }, function(error){
                             console.log("removeLocalNotification error="+error);
                         });
                     }, function(error){
                         console.log("deleteNotification error="+error);
                     });
                 }//end of for loop
             }else{
                 console.log("selectExNotification result ZERO notification scheduled");
             }
         }, function(error){
              console.log("selectExNotification error="+error);
         });*/

        self.removeAllLocalNotificationDevice();
        //console.log("### fetching all notification list from device before reschedule");
        self.printScheduledIdsInDevice();

        //console.log("## After delete ex-notify & Before re-schedule up coming notifcation");

        //self.printNotificationQ();
        // re-schedule up coming notifcation
        self.selectUpNotificationQ(nowInMinits, maxScheduleLimit).then(function(result) {
            var upNotifyCount = result.rows.length;
            if (upNotifyCount > 0) {
                var notifcationList = [];
                var i = 0;
                for (i = 0; i < upNotifyCount; i++) {
                    var notificationTimeObj = result.rows.item(i);
                    //console.log(i + ">> selectUpNotificationQ=" + JSON.stringify(notificationTimeObj));
                    notificationTimeObj.isScheduled = 1;

                    var atMS = notificationTimeObj.atInMinites * 60000;
                    var atDate = new Date();
                    //console.log(i + ">> selectUpNotificationQ b4 atDate=" + atDate);
                    atDate.setTime(atMS);
                    atDate.setSeconds(0);
                    //console.log(i + ">> selectUpNotificationQ atr atDate=" + atDate);
                    
                    //console.log(i + "### selectUpNotificationQ meditext -cypertext="+notificationTimeObj.text);
                    var mediText=aesUtil.decrypt(salt, iv, passPhrase, notificationTimeObj.text);
                    //console.log(i + "### selectUpNotificationQ meditext -mediText="+mediText);
                    
                    var objNotificationJSON = {
                        id: notificationTimeObj.id,
                        text: mediText,//notificationTimeObj.text,
                        //title: notificationTimeObj.title,
                        at: atDate,
                        icon: "res://icon.png"
                        //sound: null
                    };
                    notifcationList.push(objNotificationJSON);
                }

                if(upNotifyCount===self.maxNotifyLimit){ //reached max limit
                    var lastNotify = notifcationList[upNotifyCount - 1];
                    var objWarnNotificationJSON = {
                        id: 0,
                        text: $translate.instant("WARN_NOTIFICATION_MSG"),
                        title: lastNotify.title,
                        at: new Date(lastNotify.at),
                        icon: "res://icon.png"
                        //sound: null
                    };
                    notifcationList.push(objWarnNotificationJSON);
                }else{
                  //console.log(notifcationList.length +" is less than "+self.maxNotifyLimit+", No need open app remainder"  );
                }

                //console.log(notifcationList.length + ">> selectUpNotificationQ payload=" + JSON.stringify(notifcationList));
                self.setLocalNotificationDevice(notifcationList);
                self.hideLoader();
               /* $cordovaLocalNotification.add(notifcationList).then(function(result) {
                    self.printScheduledIdsInDevice();
                    //console.log("notification added in device:"+JSON.stringify(notificationTimeObj));
                    // self.updateNotificationScheduleQ(notificationTimeObj).then(function (result) {
                    //  console.log("The notification flag has been set in DB");
                    //});
                }, function(error) {
                    console.log("The notification NOT set in device");
                });*/
                //console.log("### fetching all notification list from device after reschedule");

            } else {
                //console.log("selectUpNotification ZERO notification scheduled");
                self.hideLoader();
            }
        }, function(error) {
            console.log("selectUpNotification error=" + error);
            self.hideLoader();
        });
        self.deleteExNotificationQ(nowInMinits);
        //console.log("## after re-schedule up coming notifcation");
       // self.printNotificationQ();
    };

    // step 1   
    self.selectExNotificationQ = function(nowInMinits) {
        //var sqlQuery = "select id, perantId,perantType,title,text,at,atInMinites,nextAtInMinites,intervalInMinites,isScheduled from NotificationQ where atInMinites<? ORDER BY atInMinites ASC";
        var sqlQuery = "select * from NotificationQ where atInMinites<? ORDER BY atInMinites ASC";

        var bindingvalues = [nowInMinits];
        return DB.query(sqlQuery, bindingvalues).then(function(result) {
            //console.log("selectExNotification data recieved : " + result.rows.length);
            return result;
        }, function(error) {
            console.log("Error reading selectExNotification Data : " + error);
            return error
        });
    };

    self.deleteExNotificationQ = function(nowInMinits) {
        //var sqlQuery = "select id, perantId,perantType,title,text,at,atInMinites,nextAtInMinites,intervalInMinites,isScheduled from NotificationQ where atInMinites<? ORDER BY atInMinites ASC";
        var sqlQuery = "delete from NotificationQ where atInMinites<?"
            //var sqlQuery = "select * from NotificationQ where atInMinites<? ORDER BY atInMinites ASC"; 
        var bindingvalues = [nowInMinits];
        return DB.query(sqlQuery, bindingvalues).then(function(result) {
            //console.log("--deleteExNotificationQ data deleted : " + result.rows.length);
            self.hideLoader();
            return result;
        }, function(error) {
            console.log("--Error reading deleteExNotificationQ Data : " + error);
            return error
        });
    }

    //step 2
    /* self.updateNotificationTimeQ = function(notificationTimeObj){
         var sqlQuery = 'update NotificationQ set atInMinites=?, isScheduled =? where id = ?';
         var bindingvalues = [notificationTimeObj.atInMinites, notificationTimeObj.isScheduled, notificationTimeObj.id];
         return DB.query(sqlQuery,bindingvalues).then(function(result){
             return result;
         },function(error){
             return error
         });
     };*/


    //step 3
    self.selectUpNotificationQ = function(nowInMinits, maxScheduleLimit) {
        //var sqlQuery = "select id, perantId,perantType,title,text,at,atInMinites,nextAtInMinites,intervalInMinites,isScheduled from NotificationQ where atInMinites>? ORDER BY atInMinites ASC LIMIT "+self.maxNotifyLimit;
        var sqlQuery = "select * from NotificationQ where atInMinites>? ORDER BY atInMinites ASC ";

        if (maxScheduleLimit) {
            sqlQuery = sqlQuery + "LIMIT " + maxScheduleLimit;
        }
        var bindingvalues = [nowInMinits];
        return DB.query(sqlQuery, bindingvalues).then(function(result) {
            //console.log("NotificationQ data recieved : " + result.rows.length);
            return result;
        }, function(error) {
            console.log("Error reading NotificationQ Data : " + error);
            return error
        });
    };

    //step 4
    self.updateNotificationScheduleQ = function(notificationTimeObj) {
        var sqlQuery = 'update NotificationQ set isScheduled =? where id = ? and isScheduled!=3 ';
        var bindingvalues = [notificationTimeObj.isScheduled, notificationTimeObj.id];
        return DB.query(sqlQuery, bindingvalues).then(function(result) {
            return result;
        }, function(error) {
            return error
        });
    };

    //step 0
    self.selectReneuableNotificationQ = function(parantId, timeingCount) {
        var sqlQuery = "select * from NotificationQ where perantId==? and perantType=='T' ORDER BY atInMinites DESC LIMIT " + timeingCount;
        var bindingvalues = [parantId];

        return DB.query(sqlQuery, bindingvalues).then(function(result) {
            //console.log("NotificationQ data recieved : " + result.rows.length);
            return result;
        }, function(error) {
            console.log("Error reading NotificationQ Data : " + error);
            return error
        });
    };

    self.printNotificationQ = function() {
        /*var sqlQuery = "select * from NotificationQ ORDER BY atInMinites ASC ";
        var bindingvalues = []; // [nowInMinits];
        DB.query(sqlQuery, bindingvalues).then(function(result) {
            var upNotifyCount = result.rows.length;
            if (upNotifyCount > 0) {
                for (var i = 0; i < upNotifyCount; i++) {
                    var notificationTimeObj = result.rows.item(i);
                    console.log("## " + i + " notificationTimeObj=" + JSON.stringify(notificationTimeObj));
                }
            }
            return result;
        }, function(error) {
            console.log("## Error reading NotificationQ Data : " + error);
            return error
        });*/
    };

});