angular.module('SEPAgenda.services', ['SEPAgenda.config','util.services']).factory('DB', function($q, DB_CONFIG, UTIL_SERVICE) {

    var self = this;
    self.db = null;

    self.contactObj = {
      id : "",
      location : "",
      name : "",
      address : "",
      phone : "",
      phoneExtra : "",
      phone2  : "",
      phone2Extra : "",
      fax : "",
      email : "",
      website : "",
      prophone : "",
      email2 : ""
   };

   self.patientGroupContactObj = {
      id : "",
      builtin : "",
      icon : "",
      name : "",
      description : "",
      address : "",
      phone  : "",
      phoneExtra : "",
      cell : "",
      email : "",
      website : ""
    };

    self.webObj = {
      id : "",
      builtin : "",
      name : "",
      description : "",
      link : ""
    };

    self.questionObj = {
       id : "",
       builtin : "",
       checked : "",
       description : ""
    };

    self.documentObj = {
       id : "",
       builtin : "",
       checked : "",
       description : ""
    };

    self.init = function() {
        if (window.sqlitePlugin) {
            
            if (ionic.Platform.isAndroid()) {
                 DB_CONFIG.name = "db14.db";
            } else {
                 DB_CONFIG.name = "db11.db";
            }

            self.db = window.sqlitePlugin.openDatabase({
                name: DB_CONFIG.name
            });
        }else {
            self.db = window.openDatabase(DB_CONFIG.name, DB_CONFIG.version, 'SEPAgenda', 200000);
        }
        angular.forEach(DB_CONFIG.tables, function(table) {
            var columns = [];
            angular.forEach(table.columns, function(column) {
                columns.push(column.name + ' ' + column.type);
            });
            var query = 'CREATE TABLE IF NOT EXISTS ' + table.name + ' (' + columns.join(',') + ')';
            self.query(query);
        });
    };
                                                                   
    self.loadDefaultValues = function() {     

        // Inserting Predefined Contacts For Health Network Contacts
        self.deleteOldHealthContacts().then(function(result){
         
             UTIL_SERVICE.jsonFileReader("modules/contacts/healthNetworkContacts.json").then(function(result){
               var jsonContactCount = result.data.healthcontacts.length;
               var contact = result.data.healthcontacts;
               
               for(var i=0;i<jsonContactCount;i++){
                  // self.setDefaultValues();
                  self.contactObj.location = contact[i].location;
                  self.contactObj.name = contact[i].name;
                  self.contactObj.address = contact[i].address;
                  self.contactObj.phone = contact[i].phone;
                  self.contactObj.phoneExtra = contact[i].phoneExtra;
                  self.contactObj.phone2  = contact[i].phone2;
                  self.contactObj.phone2Extra = contact[i].phone2Extra;
                  self.contactObj.fax = contact[i].fax;
                  self.contactObj.email = contact[i].email;
                  self.contactObj.website = contact[i].website;
                  self.contactObj.prophone = contact[i].prophone;
                  self.contactObj.email2 = contact[i].email2;
                  self.insertHealthContact(self.contactObj).then(function(result){
                  },function(error){
                    console.log("Error inserting Health Contact at "+i+"  "+error);
                  });
               }
             },
             function(error){
                  console.log("Error reading JSON Data :"+error);
             });
          
          },
          function(error) {
                  dbContactCount = error;
                  console.log("Error reading Health Contact Data ");
        });

        // Inserting Predefined Contacts For Patient Group Contacts
        self.deleteOldPatientGroupContacts().then(function(result){
                
                UTIL_SERVICE.jsonFileReader("modules/contacts/patientGroupContacts.json").then(
                      function(result){
                      var jsonContactCount = result.data.patientgroupcontacts.length;
                      var contact = result.data.patientgroupcontacts;
                        for(var i=0;i<jsonContactCount;i++){
                          // self.setDefaultValues();
                          self.patientGroupContactObj.builtin = contact[i].builtin;
                          self.patientGroupContactObj.icon = contact[i].icon;
                          self.patientGroupContactObj.name = contact[i].name;
                          self.patientGroupContactObj.description = contact[i].description;
                          self.patientGroupContactObj.address  = contact[i].address;
                          self.patientGroupContactObj.phone = contact[i].phone;
                          self.patientGroupContactObj.phoneExtra = contact[i].phoneExtra;
                          self.patientGroupContactObj.cell = contact[i].cell;
                          self.patientGroupContactObj.email = contact[i].email;
                          self.patientGroupContactObj.website = contact[i].website;
                          
                          self.insertPatientGroupContact(self.patientGroupContactObj).then(function(result){
                                 },function(error){
                                 console.log("Error inserting Patient Group Contact at "+i+"  "+error);
                                 });
                        }
                      },
                      function(error){
                        console.log("Error reading JSON Data :"+error);
                      });
                  
                },
                function(error){
                  dbContactCount = error;
                  console.log("Error reading Patient Group Contact Data ");
        });

        // Inserting Predefined Contacts For Internet Contacts
        self.deleteOldWebsites().then(function(result){
                     
                         UTIL_SERVICE.jsonFileReader("modules/contacts/websiteDetails.json").then(
                         function(result){
                           var jsonContactCount = result.data.websites.length;
                           var contact = result.data.websites;
                           for(var i=0;i<jsonContactCount;i++){
                              self.webObj.builtin = 1;
                              self.webObj.name = contact[i].name;
                              self.webObj.description = contact[i].description;
                              self.webObj.link = contact[i].link;
                              self.insertWebDetails(self.webObj).then(function(result){
                              },function(error){
                                console.log("Error inserting Website address at "+i+"  "+error);
                              });
                           }
                         },
                         function(error){
                            console.log("Error reading JSON Data :"+error);
                         });
                      
                  },
                  function(error){dbContactCount = error;
                         console.log("Error reading Website Data from DB");
        });

        // Inserting Predefined Questions
        self.deleteOldQuestions().then(function(result) {
                     
                         UTIL_SERVICE.jsonFileReader("languages/locale-en_US.json").then(
                         function(result){
                           var questions = result.data.questionslist;
                           var jsonQuestionCount = Object.keys(questions).length;
                              for(var propertyName in questions) {
                                self.questionObj.builtin = 1;
                                self.questionObj.description = questions[propertyName];

                                self.insertQuestion(self.questionObj).then(function(result){
                                },function(error){
                                  console.log("Error inserting predefined question at "+i+"  "+error);
                                });
                              }
                         },
                         function(error) {
                            console.log("Error reading JSON Data :"+error);
                         });
                      
                  },
                  function(error) {
                    dbQuestionCount = error;
                    console.log("Error reading questions data from DB");
        });

        // Inserting Predefined Documents
        self.deleteOldDocuments().then(function(result) {
                     
                         UTIL_SERVICE.jsonFileReader("languages/locale-en_US.json").then(
                         function(result){
                           var documents = result.data.documentslist;
                           var jsonDocumentCount = Object.keys(documents).length;
                           
                           for(var propertyName in documents) {
                                self.documentObj.builtin = 1;
                                self.documentObj.description = documents[propertyName];
                                
                                self.insertDocument(self.documentObj).then(function(result){
                                },function(error){
                                  console.log("Error inserting predefined documents at "+i+"  "+error);
                                });
                              }
                      
                            },
                         function(error) {
                            console.log("Error reading JSON Data :"+error);
                         });
                      
                  },
                  function(error) {
                    dbDocumentCount = error;
                    console.log("Error reading documents data from DB");
        });

        //self.migrateTreatmentData();
        self.selectAllpatientGroupContacts();
        self.selectAllprofessionalContacts();
        self.selectAllQuestions();
        self.selectAllDocuments();
    };

     self.selectAllQuestions = function(){
        var sqlQuery = 'select * from Question order by id ASC';
        self.query(sqlQuery).then(function(result){
          var pcmQuesCount = result.rows.length;
          for(var i=0;i<pcmQuesCount;i++){
            var questionValue = result.rows.item(i);
            self.updateQuestion(questionValue);
          }
            return result;
        },function(error){
            return error
        });
    };

    self.selectAllDocuments = function(){
        var sqlQuery = 'select * from Document order by id ASC';
         self.query(sqlQuery).then(function(result){
          var pcmCount = result.rows.length;
          for(var i=0;i<pcmCount;i++){
            var documentValue = result.rows.item(i);
            self.updateDocument(documentValue);
          }
            return result;
        },function(error){
            return error
        });
    };

    self.updateQuestion = function(queObj){
        var sqlQuery = 'update Question set description=? where id = ?';
        queObj.description = aesUtil.encrypt(salt, iv, passPhrase, queObj.description);
        var bindingvalues = [queObj.description, queObj.id];
        self.query(sqlQuery,bindingvalues).then(function(result){
            return result;
        },function(error){
            return error
        });
    };

    self.updateDocument = function(docObj){
        var sqlQuery = 'update Document set description=? where id = ?';
        docObj.description = aesUtil.encrypt(salt, iv, passPhrase, docObj.description);
        var bindingvalues = [docObj.description, docObj.id];
        self.query(sqlQuery,bindingvalues).then(function(result){
            return result;
        },function(error){
            return error
        });
    };

    self.selectAllpatientGroupContacts = function() {
          
          self.patientGroupContacts = [];
          var sqlQuery = 'SELECT * FROM PatientGroup ORDER BY name COLLATE NOCASE';
          self.query(sqlQuery).then(function(result){
             var contactCount = result.rows.length;
             for(var i=0;i<contactCount;i++){
                var patientGroupContacts = result.rows.item(i);
                self.updatePatientGroupContact(patientGroupContacts);
             }
                     
         return result;
         },function(error){
          console.log("Error retrieving data from Patient Group Contacts : "+error);
         return error;});
    };

    self.selectAllprofessionalContacts = function() {
      
      var sqlQuery = 'SELECT * FROM Professional ORDER BY name COLLATE NOCASE ASC';
            self.query(sqlQuery).then(function(result){
              var contactCount = result.rows.length;
              for(var i=0;i<contactCount;i++){
                var professionalContacts = result.rows.item(i);
                self.updateProfessionalContact(professionalContacts);
              }
              return result;
            },function(error){
            console.log("Error retrieving data from Professional Contacts : "+error);
              return error;
            });
    };

    self.updatePatientGroupContact = function(patientGroupContactObj){
            patientGroupContactObj.phone = aesUtil.encrypt(salt, iv, passPhrase, patientGroupContactObj.phone);
            patientGroupContactObj.cell = aesUtil.encrypt(salt, iv, passPhrase, patientGroupContactObj.cell)
            patientGroupContactObj.email = aesUtil.encrypt(salt, iv, passPhrase, patientGroupContactObj.email);
            patientGroupContactObj.address = aesUtil.encrypt(salt, iv, passPhrase, patientGroupContactObj.address);
          var sqlQuery = 'update PatientGroup set builtin=?, icon=?, name=?, description=?, address=?, phone=?, phoneExtra=?, cell=?, email=?, website=? where id = ?';
          var bindingvalues = [patientGroupContactObj.builtin,patientGroupContactObj.icon,patientGroupContactObj.name,patientGroupContactObj.description,patientGroupContactObj.address,patientGroupContactObj.phone,patientGroupContactObj.phoneExtra,patientGroupContactObj.cell,patientGroupContactObj.email,patientGroupContactObj.website,patientGroupContactObj.id];
          return self.query(sqlQuery, bindingvalues).then(function(result) {
                   return result;
                  },function(error){
                  return error;
                  });
          };

    self.updateProfessionalContact = function(professionalObj){
        var sqlQuery = 'update Professional set title=?, name=?, phone=?, cell=?, email=?, address=?, deviceId=? where id = ?';
        professionalObj.phone = aesUtil.encrypt(salt, iv, passPhrase, professionalObj.phone);
        professionalObj.cell = aesUtil.encrypt(salt, iv, passPhrase, professionalObj.cell)
        professionalObj.email = aesUtil.encrypt(salt, iv, passPhrase, professionalObj.email);
        professionalObj.address = aesUtil.encrypt(salt, iv, passPhrase, professionalObj.address);
        var bindingvalues = [professionalObj.title, professionalObj.name, professionalObj.phone, professionalObj.cell, professionalObj.email, professionalObj.address, professionalObj.deviceId, professionalObj.id];
        self.query(sqlQuery, bindingvalues).then(function(result) {
                 return result;
                },function(error){
                return error;
                });
      };

    self.migrateTreatmentData = function(){
        var sqlQuery = "UPDATE Medicine SET lastBoxOpenedDate = DATE('NOW') where lastBoxOpenedDate IS NULL";
        self.query(sqlQuery).then(function(result){
        },function(error){
           console.log("Error in updating lastBoxOpenedDate"+error);
        });


        var sqlQuery = "INSERT INTO MedicineExt (medicineId) SELECT id FROM Medicine";
        self.query(sqlQuery).then(function(result){
        },function(error){
           console.log("Error from DB for treatment migration"+error);
        });
    }

    self.deleteOldHealthContacts = function(){
        var sqlQuery = 'delete from HealthNetwork';
        return self.query(sqlQuery).then(function(result){
          return result;
        },function(error){
           console.log("Error deleting data from health contacts"+error);
          return error;
        });
   };

   self.insertHealthContact = function(contactObj) {
        var sqlQuery = 'insert or replace into HealthNetwork(location,name,address,phone,phoneExtra,phone2,phone2Extra,fax,email,website,prophone,email2) values (?,?,?,?,?,?,?,?,?,?,?,?)';
       contactObj.address = aesUtil.encrypt(salt, iv, passPhrase, contactObj.address);
       contactObj.phone = aesUtil.encrypt(salt, iv, passPhrase, contactObj.phone);
       contactObj.phoneExtra = aesUtil.encrypt(salt, iv, passPhrase, contactObj.phoneExtra);
       contactObj.phone2 = aesUtil.encrypt(salt, iv, passPhrase, contactObj.phone2);
       contactObj.phone2Extra = aesUtil.encrypt(salt, iv, passPhrase, contactObj.phone2Extra);
       contactObj.fax = aesUtil.encrypt(salt, iv, passPhrase, contactObj.fax);
       contactObj.email = aesUtil.encrypt(salt, iv, passPhrase, contactObj.email);
       contactObj.email2 = aesUtil.encrypt(salt, iv, passPhrase, contactObj.email2);
        var bindingvalues = [contactObj.location,contactObj.name,contactObj.address,contactObj.phone,contactObj.phoneExtra,contactObj.phone2,contactObj.phone2Extra,contactObj.fax,contactObj.email,contactObj.website,contactObj.prophone,contactObj.email2];
            return self.query(sqlQuery, bindingvalues).then(function(result) {
               return result;
               },function(error){
                  return error;
               });
    };

    self.deleteOldPatientGroupContacts = function(){
          var sqlQuery = 'delete from PatientGroup where builtin=1';
          return self.query(sqlQuery).then(function(result){
                       return result;
                     },function(error){
                       console.log("Error deleting data from Patient Group Contacts"+error);
                       return error;
                     });
    };

    self.insertPatientGroupContact = function(patientGroupContactObj) {
          var sqlQuery = 'insert or replace into PatientGroup(builtin, icon, name, description, address, phone, phoneExtra, cell, email, website) values (?,?,?,?,?,?,?,?,?,?)';
        
        patientGroupContactObj.address = aesUtil.encrypt(salt, iv, passPhrase, patientGroupContactObj.address);
        patientGroupContactObj.phone = aesUtil.encrypt(salt, iv, passPhrase, patientGroupContactObj.phone);
        patientGroupContactObj.cell = aesUtil.encrypt(salt, iv, passPhrase, patientGroupContactObj.cell);
        patientGroupContactObj.email = aesUtil.encrypt(salt, iv, passPhrase, patientGroupContactObj.email);
        
          var bindingvalues = [patientGroupContactObj.builtin,patientGroupContactObj.icon,patientGroupContactObj.name,patientGroupContactObj.description,patientGroupContactObj.address,patientGroupContactObj.phone,patientGroupContactObj.phoneExtra,patientGroupContactObj.cell,patientGroupContactObj.email,patientGroupContactObj.website];
          return self.query(sqlQuery, bindingvalues).then(function(result) {
                        return result;
                        },function(error){
                        return error;
                        });
    };

    self.deleteOldWebsites = function(){
        var sqlQuery = 'delete from WebSite where builtin = 1';
        return self.query(sqlQuery).then(function(result){
          return result;
        },function(error){
           console.log("Error deleting data from Website details"+error);
          return error;
        });
   };

   self.insertWebDetails = function(webObj) {
        var sqlQuery = 'insert or replace into WebSite(builtin,description,link) values (?,?,?)';
        var bindingvalues = [webObj.builtin,webObj.description,webObj.link];
        return self.query(sqlQuery, bindingvalues).then(function(result) {
                return result;
               },function(error){
                  return error;
               });
    };

    self.deleteOldQuestions = function() {
        var sqlQuery = 'delete from Question where builtin = 1';
        return self.query(sqlQuery).then(function(result){
          return result;
        },function(error){
           console.log("Error deleting data from Question"+error);
          return error;
        });
    };

    self.insertQuestion = function(questionObj) {
        var sqlQuery = 'insert or replace into Question(builtin, description, checked) values (?,?,?)';
        questionObj.description = aesUtil.encrypt(salt, iv, passPhrase, questionObj.description);
        var bindingvalues = [questionObj.builtin, questionObj.description, questionObj.checked];
        return self.query(sqlQuery, bindingvalues).then(function(result) {
          return result;
      },function(error){
          return error;
      });
    };

    self.deleteOldDocuments = function() {
        var sqlQuery = 'delete from Document where builtin = 1';
        return self.query(sqlQuery).then(function(result){
          return result;
        },function(error){
           console.log("Error deleting data from Document"+error);
          return error;
        });
    };

    self.insertDocument = function(documentObj) {
        var sqlQuery = 'insert or replace into Document(builtin, description, checked) values (?,?,?)';
        documentObj.description = aesUtil.encrypt(salt, iv, passPhrase, documentObj.description);
        var bindingvalues = [documentObj.builtin, documentObj.description, documentObj.checked];
        return self.query(sqlQuery, bindingvalues).then(function(result) {
          return result;
      },function(error){
          return error;
      });
    };
                                                               
    self.query = function(query, bindings) {
        if(self.db === null){
            if (window.sqlitePlugin) {
                if (ionic.Platform.isAndroid()) {
                     DB_CONFIG.name = "db14.db";
                } else {
                     DB_CONFIG.name = "db11.db";
                }

                self.db = window.sqlitePlugin.openDatabase({
                    name: DB_CONFIG.name
                });
            }else {
                self.db = window.openDatabase(DB_CONFIG.name, DB_CONFIG.version, 'SEPAgenda', 200000);
            }
         }
        bindings = typeof bindings !== 'undefined' ? bindings : [];
        var deferred = $q.defer();
        self.db.transaction(function(transaction) {
            transaction.executeSql(query, bindings, function(transaction, result) {
                deferred.resolve(result);
            }, function(transaction, error) {
                console.log('database Error' + transaction + 'error' + error);
                deferred.reject(error);
            });
        });
        return deferred.promise;
    };
                                                                   
    return self;
});