  angular.module('ProfessionalContacts.services', ['SEPAgenda.services','util.services']).factory('professionalService', function($q,DB,UTIL_SERVICE) {
                                                                                            
      var prof = this;
                                                                                      
      prof.professionalContacts = [];
                                                                                            
      prof.professionalObj = {
            id : "",
            title : "",
            name : "",
            phone : "",
            cell : "",
            email : "",
            address : "",
            deviceId : ""
      };

      prof.insertProfessionalContact = function(professionalObj) {
      var sqlQuery = 'insert or replace into Professional(title, name, phone, cell, email, address, deviceId) values (?,?,?,?,?,?,?)';
      professionalObj.phone = aesUtil.encrypt(salt, iv, passPhrase, professionalObj.phone);
      professionalObj.cell = aesUtil.encrypt(salt, iv, passPhrase, professionalObj.cell)
      professionalObj.email = aesUtil.encrypt(salt, iv, passPhrase, professionalObj.email);
      professionalObj.address = aesUtil.encrypt(salt, iv, passPhrase, professionalObj.address);
      var bindingvalues = [professionalObj.title, professionalObj.name, professionalObj.phone, professionalObj.cell, professionalObj.email, professionalObj.address, professionalObj.deviceId];
            return DB.query(sqlQuery, bindingvalues).then(function(result) {
            //return result.insertId;
            return result;
            },function(error){
            return error;
            });
      };

      prof.updateProfessionalContact = function(professionalObj){
        var sqlQuery = 'update Professional set title=?, name=?, phone=?, cell=?, email=?, address=?, deviceId=? where id = ?';
        professionalObj.phone = aesUtil.encrypt(salt, iv, passPhrase, professionalObj.phone);
        professionalObj.cell = aesUtil.encrypt(salt, iv, passPhrase, professionalObj.cell)
        professionalObj.email = aesUtil.encrypt(salt, iv, passPhrase, professionalObj.email);
        professionalObj.address = aesUtil.encrypt(salt, iv, passPhrase, professionalObj.address);
        var bindingvalues = [professionalObj.title, professionalObj.name, professionalObj.phone, professionalObj.cell, professionalObj.email, professionalObj.address, professionalObj.deviceId, professionalObj.id];
        return DB.query(sqlQuery, bindingvalues).then(function(result) {
                 return result;
                },function(error){
                return error;
                });
      };

      prof.deleteProfessionalContact = function(professionalObj){
        var deferred = $q.defer();
        var sqlQuery = 'delete from Professional where id=?';
        var bindingvalues = [professionalObj.id];
        DB.query(sqlQuery,bindingvalues).then(function(result){
          deferred.resolve(result);
        },function(error){deferred.reject(error);});
        return deferred.promise;
   };

      prof.countOfProfessionalContacts = function(){
      var sqlQuery = 'select count(*) as cnt from Professional';
            return DB.query(sqlQuery).then(function(result){
            //return result.rows.item(0).cnt;
            return result;
            },function(error){
            console.log("Error retrieving data from Professional Contacts"+error);
            return error;
            });
      };

      prof.selectAllprofessionalContacts = function(){
      prof.professionalContacts = [];
      var sqlQuery = 'SELECT * FROM Professional ORDER BY name COLLATE NOCASE ASC';
            return DB.query(sqlQuery).then(function(result){
            /*var contactCount = result.rows.length;
            for(var i=0;i<contactCount;i++){
            prof.professionalContacts.push(result.rows.item(i));
            }*/
            return result;
            },function(error){
            console.log("Error retrieving data from Professional Contacts : "+error);
            return error;
            });
      };

      prof.getProfessionalContact = function(id){
      var profConCount = prof.professionalContacts.length;
            for(var i=0;i<profConCount;i++){
                  if(prof.professionalContacts[i].id === parseInt(id)){
                        return prof.professionalContacts[i]; 
                  }
            }                                                                              
      };
      
      return prof;
});