angular.module('Website.services', ['SEPAgenda.services','util.services']).factory('websiteService', function($q,DB,UTIL_SERVICE) {

    var self = this;

    self.webDetails = [];

    self.webObj = {
       id : "",
       builtin : "",
       name : "",
       description : "",
       link : ""
    };
                                                                       

                                                                       
   self.init = function(){
    self.countOfWebsites().then(
      function(result){
         var dbContactCount = result.rows.item(0).cnt;
          if(dbContactCount == 0){
             UTIL_SERVICE.jsonFileReader("modules/contacts/websiteDetails.json").then(
             function(result){
               var jsonContactCount = result.data.websites.length;
               var contact = result.data.websites;
               for(var i=0;i<jsonContactCount;i++){
                  self.webObj.builtin = 1;
                  self.webObj.name = contact[i].name;
                  self.webObj.description = contact[i].description;
                  self.webObj.link = contact[i].link;
                  self.insertWebDetails(self.webObj).then(function(result){
                  },function(error){
                    console.log("Error inserting Website address at "+i+"  "+error);
                  });
               }
             },
             function(error){
                console.log("Error reading JSON Data :"+error);
             });
          }
      },
      function(error){dbContactCount = error;
             console.log("Error reading Website Data from DB");
    });
   };

   self.insertWebDetails = function(webObj) {
        var sqlQuery = 'insert or replace into WebSite(builtin,description,link) values (?,?,?)';
        var bindingvalues = [webObj.builtin,webObj.description,webObj.link];
        return DB.query(sqlQuery, bindingvalues).then(function(result) {
                return result;
               },function(error){
                  return error;
               });
    };

   self.updateWebDetails = function(webObj){
        var sqlQuery = 'update WebSite set description=?,link=? where id = ?';
        var bindingvalues = [webObj.description,webObj.link,webObj.id];
        return DB.query(sqlQuery, bindingvalues).then(function(result) {
                 return result;
                },function(error){
                return error;
                });
   };
                                                                       
   self.deleteWebDetails = function(webObj){
        var sqlQuery = 'delete from WebSite where id=?';
        var bindingvalues = [webObj.id];
        return DB.query(sqlQuery,bindingvalues).then(function(result){
         /*  var countOfWeb = self.webDetails.length;
           for(var i=0;i<countOfWeb;i++){
             if(self.webDetails[i].id === webObj.id){
                self.webDetails.splice(i,1);
             }
           } */
           return result;
        },function(error){return error});
   };
                                                                       
   self.countOfWebsites = function(){
        var sqlQuery = 'select count(*) as cnt from WebSite where builtin = ?';
        var bindingvalues = ['1'];
        return DB.query(sqlQuery,bindingvalues).then(function(result){
          return result;
        },function(error){
           console.log("Error retrieving data from Website details"+error);
          return error;
        });
   };

   self.selectAllWebSites = function(){
        self.webDetails = [];
        var sqlQuery = 'SELECT * FROM WebSite ORDER BY description COLLATE NOCASE ASC';
        return DB.query(sqlQuery).then(function(result){
        /*  var contactCount = result.rows.length;
          for(var i=0;i<contactCount;i++){
              self.webDetails.push(result.rows.item(i));
          }
          return self.webDetails; */
          return result;
        },function(error){
           console.log("Error retrieving data from website table : "+error);
          return error});
   };

   self.getWebsiteDetails = function(id){
            var webCount = self.webDetails.length;
            for(var i=0;i<webCount;i++){
              if(self.webDetails[i].id === parseInt(id)){
                  return self.webDetails[i]; 
              }
          }                                                                              
   };
                                                                                                                                                                                              
    return self;
});