angular.module('Appointment.services', ['SEPAgenda.services']).factory('appntService', function($q,$filter,DB) {

    var self = this;

    self.eventsList = [];
    self.appointmentsOnDate = [];                                                                 
                                                                       
   self.insertAppointment = function(eventObj) {
        var sqlQuery = 'insert or replace into Appointment(apttype,aptdate,description,reminder0,reminder1,reminder7) values (?,?,?,?,?,?)';
        var bindingvalues = [eventObj.apttype,eventObj.aptdate,eventObj.description,eventObj.reminder0,eventObj.reminder1,eventObj.reminder7];
        return DB.query(sqlQuery, bindingvalues).then(function(result) {
               return result;
               },function(error){
               console.log("Error inserting into Appointment");
                  return error;
               });
    };
                                                                       
    self.insertEvent = function(eventObj){
          var deferred = $q.defer();
          self.insertAppointment(eventObj).then(function(result){
          eventObj.id = result.insertId;
          var sqlQuery1 = 'insert or replace into AgendaEvents(eventId,appointmentId,contactName,reminder8) values (?,?,?,?)';
          eventObj.contactName = aesUtil.encrypt(salt, iv, passPhrase,eventObj.contactName);
          var bindingvalues1 = [eventObj.eventId,eventObj.id,eventObj.contactName,eventObj.reminder8];
          DB.query(sqlQuery1,bindingvalues1).then(function(result) {
                deferred.resolve(result);
               },function(error){
                  console.log("Problem inserting Events data into AgendaEvents DB");
                deferred.reject(error);
               });
          },function(error){
             console.log("Problem inserting Appointment into DB");
              deferred.reject(error);  
         });
          return deferred.promise;
    };


   self.updateEvent = function(eventObj){
        
        var deferred = $q.defer();
        var sqlQuery = 'update Appointment set apttype=?,aptdate=?,description=?,reminder0=?,reminder1=?,reminder7=? where id = ?';
        var bindingvalues = [eventObj.apttype,eventObj.aptdate,eventObj.description,eventObj.reminder0,eventObj.reminder1,eventObj.reminder7,eventObj.id];
        DB.query(sqlQuery, bindingvalues).then(function(result) {
                  var sqlQuery = 'select * from AgendaEvents where appointmentId = ?'; 
                  var bindingvalues = [eventObj.id];
                  DB.query(sqlQuery, bindingvalues).then(function(result) {
                  var agendaEventsCount = result.rows.length;
                  eventObj.contactName = aesUtil.encrypt(salt, iv, passPhrase,eventObj.contactName);
                  if(agendaEventsCount > 0) {
                      var sqlQuery1 = 'update AgendaEvents set contactName=?,reminder8=? where appointmentId = ?';
                      var bindingvalues1 = [eventObj.contactName,eventObj.reminder8,eventObj.id];
                      DB.query(sqlQuery1, bindingvalues1).then(function(result) {
                          deferred.resolve(result);
                      },function(error){
                          console.log("Error Updating AgendaEvents Data");
                          deferred.reject(error);
                      });
                  } else {
                      var sqlQuery2 = 'insert or replace into AgendaEvents(eventId,appointmentId,contactName,reminder8) values (?,?,?,?)';
                      var bindingvalues2 = [eventObj.eventId,eventObj.id,eventObj.contactName,eventObj.reminder8];
                      DB.query(sqlQuery2,bindingvalues2).then(function(result) {
                          deferred.resolve(result);
                      },function(error){
                          console.log("Problem inserting Events data into AgendaEvents DB");
                          deferred.reject(error);
                      });
                  }

                  deferred.resolve(result);
                },function(error){
                  console.log("Error Checking Agenda Events Record Exists");
                   deferred.reject(error);
                });

                
                },function(error){
                  console.log("Error Updating Appointment Data");
                  deferred.reject(error);
                });
       return deferred.promise;
   };
                                                                       
   self.deleteEvent = function(eventObj){
        var deferred = $q.defer();
        var sqlQuery = 'delete from AgendaEvents where eventId=?';
        var bindingvalues = [eventObj.eventId];
        DB.query(sqlQuery,bindingvalues).then(function(result){
            var sqlQuery1 = 'delete from Appointment where id=?';
            var bindingvalues1 = [eventObj.id];
            DB.query(sqlQuery1,bindingvalues1).then(function(result){
              var sqlQuery2 = 'delete from PrepareMyConsultation where eventId=?';
              var bindingvalues2 = [eventObj.id];
              DB.query(sqlQuery2,bindingvalues2).then(function(result){
                deferred.resolve(result);
              },function(error){deferred.reject(error);});
              deferred.resolve(result);
            },function(error){deferred.reject(error);});
        },function(error){deferred.reject(error);});
        return deferred.promise;
   };
                                                                       
   self.selectAllAppointments = function(){
        var sqlQuery = 'select a.id,a.apttype,a.aptdate,a.description,a.reminder0,a.reminder1,a.reminder7,e.reminder8,e.contactName,e.eventId,e.appointmentId from Appointment a LEFT JOIN AgendaEvents e ON a.id = e.appointmentId ORDER BY a.aptdate';
        return DB.query(sqlQuery).then(function(result){
            return result;
        },function(error){
            console.log("Error reading Events Data : "+error);
            return error});
   };

 self.countAppointmentsByDateFromToDate = function(d, endDate){
        var fromDateEvents = {};
        var fromDate = self.dateInMilliSeconds(d);
        var endDateMS = self.dateInMilliSeconds(endDate);
        
        var appntLength = self.eventsList.length;
        for(var i=0;i<appntLength;i++){
           var appntDateInSeconds = self.dateInMilliSeconds(self.eventsList[i].aptdate);
           if(appntDateInSeconds >= fromDate && appntDateInSeconds<=endDateMS){
            var objAptDate=new Date(appntDateInSeconds);
            var aptDDMMYYYY=$filter('date')(objAptDate, "dd MM yyyy");
             var count=  fromDateEvents[aptDDMMYYYY];
             if(count){
                count=count+1;
                fromDateEvents[aptDDMMYYYY]=count;
             }else{
                fromDateEvents[aptDDMMYYYY]=1;
             }
           }
        }
        return fromDateEvents;
  };

  self.selectAppointmentsFromToDate = function(d, endDate){
        var fromDateEvents = [];
        var fromDate = self.dateInMilliSeconds(d);
        var endDateMS = self.dateInMilliSeconds(endDate);
        var appntLength = self.eventsList.length;
        for(var i=0;i<appntLength;i++){
           var appntDateInSeconds = self.dateInMilliSeconds(self.eventsList[i].aptdate);
           if(appntDateInSeconds >= fromDate && appntDateInSeconds<=endDateMS){
               var objAptDate=new Date(appntDateInSeconds);
               self.eventsList[i].aptTime=$filter('date')(objAptDate, "HH 'h' mm");
               fromDateEvents.push(self.eventsList[i]);
           }
        }
        //self.eventsList = [];
        // self.eventsList = fromDateEvents;
        return fromDateEvents;//self.eventsList;
  };
                                                                       
   self.selectAppointmentsFromDate = function(d){
        var fromDateEvents = [];
        var fromDate = self.dateInMilliSeconds(d);
        var appntLength = self.eventsList.length;
        for(var i=0;i<appntLength;i++){
           var appntDateInSeconds = self.dateInMilliSeconds(self.eventsList[i].aptdate);
           if(appntDateInSeconds >= fromDate){
               var objAptDate=new Date(appntDateInSeconds);
               self.eventsList[i].aptTime=$filter('date')(objAptDate, "HH 'h' mm");
               fromDateEvents.push(self.eventsList[i]);
           }
        }
        // self.eventsList = [];
        //self.eventsList = fromDateEvents;
        return fromDateEvents;//self.eventsList;
    };
                                                                       
   self.selectAppointmentsOnDate = function(dt) {
        var selectedDayEvents = [];
        var selectedDate = new Date(dt);
            selectedDate.setHours(0);
            selectedDate.setMinutes(0);
            selectedDate.setSeconds(0);
        var fromDate =  Date.parse(selectedDate);
        
            selectedDate.setHours(23);
            selectedDate.setMinutes(59);
            selectedDate.setSeconds(59);
        var endDate  =  Date.parse(selectedDate);
        var appntLength = self.eventsList.length;
        for(var i=0;i<appntLength;i++){
           var appntDateInSeconds = self.dateInMilliSeconds(self.eventsList[i].aptdate);
           if(appntDateInSeconds >= fromDate && appntDateInSeconds <= endDate) {
               var objAptDate=new Date(appntDateInSeconds);
               self.eventsList[i].aptTime=$filter('date')(objAptDate, "HH 'h' mm");
               selectedDayEvents.push(self.eventsList[i]);
           }
        }
        self.appointmentsOnDate = selectedDayEvents;
        return self.appointmentsOnDate;
   };

  self.getEvent = function(id){
            var eventCount = self.eventsList.length;
            for(var i=0;i<eventCount;i++){
              if(self.eventsList[i].id === parseInt(id)){
                  return self.eventsList[i]; 
              }
          }                                                                              
   };
    
   self.dateInMilliSeconds = function(dt){
          var milliSeconds = Date.parse(dt);
          return milliSeconds;
   };                                                                                                                                
    return self;
});