angular.module('PrepareMyConsultation.services', ['SEPAgenda.services']).factory('prepareMyConsultationService', function($q,$filter,DB) {

	var self = this;

	self.pmcDetails = [];

	self.pmcObj = {
		id : "",
		eventId : "",
		consultationQuestions : "",
		consultationDocuments : ""
	};

	self.questionDetails = [];

	self.questionObj = {
       id : "",
       builtin : "",
       checked : "",
       description : ""
    };

	self.documentDetails = [];

    self.documentObj = {
       id : "",
       builtin : "",
       checked : "",
       description : ""
    };

    // Add a new question
	self.insertQuestion = function(questionObj) {
        var sqlQuery = 'insert or replace into Question(builtin, description, checked) values (?,?,?)';
        questionObj.description = aesUtil.encrypt(salt, iv, passPhrase, questionObj.description);
        var bindingvalues = [questionObj.builtin, questionObj.description, questionObj.checked];
        return DB.query(sqlQuery, bindingvalues).then(function(result) {
	        return result;
	    },function(error){
	        return error;
	    });
    };
          
   // Delete the user added question                                                             
   self.deleteQuestion = function(questionObj){
        var sqlQuery = 'delete from Question where id=? and builtin=0';
        var bindingvalues = [questionObj.id];
        return DB.query(sqlQuery,bindingvalues).then(function(result){
           	return result;
        },function(error){
           	return error
       	});
   };

   // Add a new document
   self.insertDocument = function(documentObj) {
        var sqlQuery = 'insert or replace into Document(builtin, description, checked) values (?,?,?)';
        documentObj.description = aesUtil.encrypt(salt, iv, passPhrase, documentObj.description);
        var bindingvalues = [documentObj.builtin, documentObj.description, documentObj.checked];
        return DB.query(sqlQuery, bindingvalues).then(function(result) {
          	return result;
       	},function(error){
          	return error;
       	});
    };
                  
   // Delete the user added document                                                     
   self.deleteDocument = function(documentObj){
        var sqlQuery = 'delete from Document where id=? and builtin=0';
        var bindingvalues = [documentObj.id];
        return DB.query(sqlQuery,bindingvalues).then(function(result){
           	return result;
        },function(error){
           	return error
       	});
   };

   // Insert a new record with event ID mapped with Question and Document separately (2 Records)
   self.insertConsultationEvent = function(pmcObj) {
        var sqlQuery = 'insert or replace into PrepareMyConsultation(eventId, consultationQuestions, consultationDocuments) values (?,?,?)';
        var bindingvalues = [pmcObj.eventId, pmcObj.consultationQuestions, pmcObj.consultationDocuments];
        return DB.query(sqlQuery, bindingvalues).then(function(result) {
	        return result;
	    },function(error){
	        return error;
	    });
    };

    // Update the questions mapped to particular event w.r.t Event ID
    self.updateQuestionEvent = function(pmcObj){
        var sqlQuery = 'update PrepareMyConsultation set consultationQuestions=? where eventId = ?';
        var bindingvalues = [pmcObj.consultationQuestions, pmcObj.eventId];
        return DB.query(sqlQuery,bindingvalues).then(function(result){
           	return result;
        },function(error){
           	return error
       	});
   	};

   	// Update the documents mapped to particular event w.r.t Event ID
   	self.updateDocumentEvent = function(pmcObj){
        var sqlQuery = 'update PrepareMyConsultation set consultationDocuments=? where eventId = ?';
        var bindingvalues = [pmcObj.consultationDocuments, pmcObj.eventId];
        return DB.query(sqlQuery,bindingvalues).then(function(result){
           	return result;
        },function(error){
           	return error
       	});
   	};

   	// Retrieves all the events with their respective consultation type (Questions and Documents)
    self.selectAllPCMEvents = function(){
      
        var sqlQuery = 'select * from PrepareMyConsultation order by id ASC';

        return DB.query(sqlQuery).then(function(result){
        	/*var pcmCount = result.rows.length;
	        for(var i=0;i<pcmCount;i++){
	          self.pmcDetails.push(result.rows.item(i));
	        }
          	return self.pmcDetails;*/
           	return result;
        },function(error){
            console.log(error);
           	return error
       	});
    };

    //Select items based on events
     self.getPmcdataForEvent = function(id){
            var pmcCount = self.pmcDetails.length;
            for(var i=0;i<pmcCount;i++){
              if(self.pmcDetails[i].eventId === parseInt(id)){
                  return self.pmcDetails[i]; 
              }
          }                                                                              
   };

    // Retrieves all the questions
    self.selectAllQuestions = function(){
        var sqlQuery = 'select * from Question order by id ASC';
        return DB.query(sqlQuery).then(function(result){
          /*var pcmCount = result.rows.length;
          for(var i=0;i<pcmCount;i++){
            self.pmcDetails.push(result.rows.item(i));
          }
          return self.pmcDetails;*/
            return result;
        },function(error){
            return error
        });
    };

    // Retrieves all the documents
    self.selectAllDocuments = function(){
        var sqlQuery = 'select * from Document order by id ASC';
        return DB.query(sqlQuery).then(function(result){
          /*var pcmCount = result.rows.length;
          for(var i=0;i<pcmCount;i++){
            self.pmcDetails.push(result.rows.item(i));
          }
          return self.pmcDetails;*/
            return result;
        },function(error){
            return error
        });
    };

   return self;
});