angular.module('splashController',['AppInfo.services']).controller('splashCtrl', function($scope, $rootScope, $ionicNavBarDelegate, $state,appInfoService,  DB, appntService, $cordovaCalendar,notificationutil,treatmentService) {
               
     $scope.treatmentsCount = 0;
     $scope.treatmentArray = [];

     $scope.init = function() {
          setTimeout(function() {
               if(localStorage.getItem("triggerReminderForMigration") !== undefined && (localStorage.getItem("triggerReminderForMigration") === true || localStorage.getItem("triggerReminderForMigration") === "true")){
                    $scope.fetchAllTreatments();
                    $scope.activateRemindersforEvents();
                    localStorage.setItem("triggerReminderForMigration", false);
               } else{
                    //reschedule iOS Notification
                    //if(!ionic.Platform.isAndroid()) {
                         notificationutil.resetNotificationQ();
                    //}
               }

               $rootScope.firstLaunchHome = true;
               appInfoService.isFirstLaunch().then(function(result) {
                    var rowCount = result.rows.item(0).cnt;
                    if (rowCount > 0) {
                    appInfoService.isTermsVisited().then(function(result) {
                                             var termsVisited = result.rows.item(0).fl;
                                             if (termsVisited === 'done') {
                                             $rootScope.firstLaunchHome = false;
                                             $state.go('home');
                                             } else {
                                             $state.go('welcome');
                                             }
                                             }, function(error) {
                                             console.log("Error : Error reading AppInfo table data");
                                             });
                    } else {
                    appInfoService.insertAppInfo();
                    $state.go('welcome');
                    }
                    
               }, function(error) {
                    console.log("Error : Initial DB Interaction failed");
               });
          }, 3000);
          
     };

     $scope.fetchAllTreatments = function(){
          treatmentService.selectAllTreatmentMedicines().then(function (result) {
               $scope.treatmentsCount = result.rows.length;
               $scope.treatmentArray = result.rows;
               $scope.masterTreatmentArray = [];
               if($scope.treatmentsCount>0){
                    for(var i=0;i<$scope.treatmentsCount;i++){
                         var treatment = $scope.treatmentArray.item(i);
                         var tempItem = treatment;
                         var timeSlots = [];
                         var timeSlotLength = 0;
                         if(tempItem.doseHour != null && tempItem.doseMinute != null) {
                            tempItem.durationType = 1;
                            var doseHourArray = tempItem.doseHour.split("!");
                            var doseMinuteArray = tempItem.doseMinute.split("!");

                            for(var iSlot in doseHourArray) {
                                if(!isNaN(doseHourArray[iSlot])) {
                                    var timeSlotValue;
                                    timeSlotValue = ((doseHourArray[iSlot]) < 10) ? "0"+doseHourArray[iSlot]+ " h " : doseHourArray[iSlot]+ " h ";
                                    timeSlotValue += ((doseMinuteArray[iSlot]) < 10) ? "0"+doseMinuteArray[iSlot] : doseMinuteArray[iSlot];    
                                    timeSlots.push({index:timeSlotLength, id:parseInt(timeSlotLength)+1, value: timeSlotValue, meal:""});
                                    timeSlotLength += 1;
                                } 
                            }

                            if(timeSlots.length > 0){
                                tempItem.reminderOther = JSON.stringify(timeSlots);
                            } else{
                                tempItem.reminderOther = 0;
                            }

                              var lastBoxDate = new Date();
                              if(tempItem.lastBoxOpenedDate !== null){
                                   lastBoxDate = new Date(tempItem.lastBoxOpenedDate);
                              } 
                              tempItem.lastBoxOpenedDate = lastBoxDate
                              tempItem.medicineStartDate = lastBoxDate;
                              tempItem.reminderMatin = 0;
                              tempItem.reminderMidi = 0;
                              tempItem.reminderSoir = 0;

                              var doseFrequenceUnit = tempItem.doseFrequencyUnit;
                            
                            if(doseFrequenceUnit == 2) {
                              
                              tempItem.doseFrequencyUnit = 4;
                              tempItem.doseFrequencyUnitValue = "2,1";

                            } else if(doseFrequenceUnit == 3) {
                              
                              tempItem.doseFrequencyUnit = 2;
                              var treatmentDay = parseInt(lastBoxDate.getDay());
                              tempItem.doseFrequencyUnitValue = (treatmentDay == 0) ? 7 : treatmentDay;                            


                            } else if(doseFrequenceUnit == 4) {
                              
                              tempItem.doseFrequencyUnit = 3;
                              tempItem.doseFrequencyUnitValue = parseInt(lastBoxDate.getDate());;

                            }

                            if(tempItem.fileName === null || tempItem.fileName === "null"){
                                tempItem.fileName = "./img/Camera@3x.png";
                            }
                            tempItem.doseHour = null;
                            tempItem.doseMinute = null;
                        }
                        var treatmentDataForService = angular.copy(tempItem);
                        treatmentService.updateTreatmentMedicine(tempItem);
                        $scope.masterTreatmentArray.push(treatmentDataForService);
                    }
                    if($scope.masterTreatmentArray.length > 0){
                         notificationutil.addAllNotification($scope.masterTreatmentArray);
                    }
               }
          },function(error){});
     }
     
     $scope.activateRemindersforEvents = function(){
           $scope.activeEventsList = [];
           $scope.activeEventNo = 0;
           appntService.selectAllAppointments().then(function(result){
               var eventsCount = result.rows.length;
               if(eventsCount>0){
                    for(var i=0;i<eventsCount;i++){
                        var event = result.rows.item(i);
                        // $scope.updateEvents(event,activate);
                        event.contactName = aesUtil.decrypt(salt, iv, passPhrase,event.contactName);
                        $scope.activeEventsList.push(event);
                    }
                    $scope.updateEvents($scope.activeEventsList[0]);
               }
           },function(error){
                console.log("Error reading Events Data : "+error);
            });
       }

       $scope.getEventEndDate=function(startDateTime){
          return new Date(startDateTime.getTime()+(60*60*1000));
      }
       
       $scope.updateEvents = function(event){
            $scope.dateinfo = {};
            var date = new Date(event.aptdate);
            $scope.dateinfo.date = date.getDate();
            $scope.dateinfo.month = date.getMonth();
            $scope.dateinfo.fullyear = date.getFullYear();
            $scope.dateinfo.hours = date.getHours();
            $scope.dateinfo.minutes = date.getMinutes();
            var oldEventData=event;

            var startDateTime=new Date($scope.dateinfo.fullyear, $scope.dateinfo.month, $scope.dateinfo.date, $scope.dateinfo.hours, $scope.dateinfo.minutes, 0, 0, 0);
            var endDateTime = $scope.getEventEndDate(startDateTime);

            var strAvec=(oldEventData.contactName!=="" && oldEventData.contactName !== null && oldEventData.contactName !== "null") ? " avec " +$scope.event.contactName:""; 
        
            var objOldEventJson={
              title: oldEventData.description + strAvec,//oldEventData.contactName,
              //location: oldEventData.apttype,
              notes: oldEventData.description,
              startDate:startDateTime, 
              endDate: endDateTime
           };
            $cordovaCalendar.deleteEvent(objOldEventJson).then(function (result) {
                var options1 = $scope.getEvent(event);
                $cordovaCalendar.createEventWithOptions(options1).then(function (result) {
                    $scope.activeEventNo += 1;
                    if($scope.activeEventsList.length > $scope.activeEventNo){
                        $scope.updateEvents($scope.activeEventsList[$scope.activeEventNo]);
                    }
                },function(error){
                    console.log("error while updating in settings module"+error);
                });
            },function(error){
                console.log("error while updating in settings module"+error);
            });
       }
       
       $scope.getEvent=function(event){
                var date = new Date(event.aptdate);
          
                var startDateTime=new Date(date.getFullYear(), date.getMonth(), date.getDate(), date.getHours(), date.getMinutes(), 0, 0, 0);
                var endDateTime = new Date(startDateTime.getTime()+(60*60*1000));


                var strAvec=(event.contactName!=="" && event.contactName !== null && event.contactName !== "null") ? " avec " +event.contactName:"";
                var objEventJson={
                    title: event.description+strAvec,
                    location: null,//event.apttype,
                    notes: event.description,
                    startDate: startDateTime,
                    endDate: endDateTime,
                    firstReminderMinutes: null,
                    secondReminderMinutes: null,
                    recurrence: null, // options are: 'daily', 'weekly', 'monthly', 'yearly'
                    recurrenceInterval: 1, // only used when recurrence is set
                    recurrenceEndDate: null,
                    calendarName: null,
                    calendarId: null,
                    url: null
                };

                    var slotTimeInMinutes = [10080, 1440, 120, 60];
                    var reminderSlotPosition = [event.reminder7, event.reminder1, event.reminder8, event.reminder0];
                    var selectedSlotTime = [];
                    for(var rSlot in reminderSlotPosition){
                        if(parseInt(reminderSlotPosition[rSlot]) === 1){
                            selectedSlotTime.push(slotTimeInMinutes[rSlot]);
                        }
                    }

                    if(selectedSlotTime[0] != undefined){
                        objEventJson.firstReminderMinutes=selectedSlotTime[0];
                    }
                    if(selectedSlotTime[1] != undefined){
                        objEventJson.secondReminderMinutes=selectedSlotTime[1];
                    }
                    
                    return objEventJson;
         }


});