angular.module('Treatment.services', ['SEPAgenda.services','util.services']).factory('treatmentService', function($q, $filter, DB, $translate, UTIL_SERVICE) {

		  var self = this;
          
          self.treatmentArray = [];
          self.calendarTreatmentArray = [];
          self.masterFetchedArray = [];
          
          self.treatmentArrayObj = {
          	  doseUnit : "",
              id : "",
              type : "1",
              name : "Knee Pain",
              doseFrequency : "2",
              doseFrequencyUnit : "1",
              doseHour : "9",
              doseMinute  : "10",
              lastDoseTakenDate : "",
              boxCapacity : "",
              lastBoxOpenedDate : "",
              newBoxScheduledDate : "",
              doseTakenCount  : "0",
              medicineId : "",
              medicineType  : "3",
              durationType  : "Indetermine",
              reminderMatin  : "1",
              reminderMidi  : "0",
              reminderSoir  : "1",
              boiteNote  : "Treatment Notes",
              fileName  : "kneepic",
              medicineIntake : "After food",
              deleteNotifyFlag : "",
              lastIgnoreDate : "",
              doseFrequencyUnitValue : "",
              durationValue : "",
              matinStatus : "",
              midiStatus : "",
              soirStatus : "",
              medicineStartDate : "",
              reminderOther: "",
              otherStatus:","
          };

    self.insertMainMedicine = function(treatmentArrayObj) {
        var sqlQuery = 'insert or replace into Medicine(doseUnit, type, name, doseFrequency, doseFrequencyUnit, doseHour, doseMinute, lastDoseTakenDate, boxCapacity, lastBoxOpenedDate, newBoxScheduledDate, doseTakenCount) values (?,?,?,?,?,?,?,?,?,?,?,?)';
        var bindingvalues = [treatmentArrayObj.doseUnit, treatmentArrayObj.type, treatmentArrayObj.name, treatmentArrayObj.doseFrequency, treatmentArrayObj.doseFrequencyUnit, treatmentArrayObj.doseHour, treatmentArrayObj.doseMinute, treatmentArrayObj.lastDoseTakenDate, treatmentArrayObj.boxCapacity, treatmentArrayObj.lastBoxOpenedDate, treatmentArrayObj.newBoxScheduledDate, treatmentArrayObj.doseTakenCount];
        return DB.query(sqlQuery, bindingvalues).then(function(result) {
               return result;
               },function(error){
               console.log("Error inserting into Medicine");
                  return error;
               });
    };
                                                                       
    self.insertTreatmentMedicine = function(treatmentArrayObj){
          var deferred = $q.defer();
          treatmentArrayObj.name = aesUtil.encrypt(salt, iv, passPhrase, treatmentArrayObj.name);
          treatmentArrayObj.boiteNote = aesUtil.encrypt(salt, iv, passPhrase, treatmentArrayObj.boiteNote);
          self.insertMainMedicine(treatmentArrayObj).then(function(result){
          treatmentArrayObj.medicineId = result.insertId;
          var sqlQuery1 = 'insert or replace into MedicineExt(medicineId, medicineType, durationType, reminderMatin, reminderMidi, reminderSoir, boiteNote, fileName, medicineIntake, deleteNotifyFlag, lastIgnoreDate, doseFrequencyUnitValue, durationValue, matinStatus, midiStatus, soirStatus, medicineStartDate, reminderOther, otherStatus) values (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)';
          var bindingvalues1 = [treatmentArrayObj.medicineId, treatmentArrayObj.medicineType, treatmentArrayObj.durationType, treatmentArrayObj.reminderMatin, treatmentArrayObj.reminderMidi, treatmentArrayObj.reminderSoir, treatmentArrayObj.boiteNote, treatmentArrayObj.fileName, treatmentArrayObj.medicineIntake, treatmentArrayObj.deleteNotifyFlag, treatmentArrayObj.lastIgnoreDate, treatmentArrayObj.doseFrequencyUnitValue, treatmentArrayObj.durationValue, treatmentArrayObj.matinStatus, treatmentArrayObj.midiStatus, treatmentArrayObj.soirStatus, treatmentArrayObj.medicineStartDate, treatmentArrayObj.reminderOther, treatmentArrayObj.otherStatus];
          DB.query(sqlQuery1,bindingvalues1).then(function(result) {
                deferred.resolve(result);
               },function(error){
                  console.log("Problem inserting extended medicine data into MedicineExt DB");
                deferred.reject(error);
               });
          },function(error){
             console.log("Problem inserting Medicine into DB");
              deferred.reject(error);  
         });
          return deferred.promise;
    };

//   self.insertTreatmentMedicine(self.treatmentArrayObj);


   self.updateTreatmentMedicine = function(treatmentArrayObj){
        var deferred = $q.defer();
        treatmentArrayObj.name = aesUtil.encrypt(salt, iv, passPhrase, treatmentArrayObj.name);
        treatmentArrayObj.boiteNote = aesUtil.encrypt(salt, iv, passPhrase, treatmentArrayObj.boiteNote);
        var sqlQuery = 'update Medicine set doseUnit=?, type=?, name=?, doseFrequency=?, doseFrequencyUnit=?, doseHour=?, doseMinute=?, lastDoseTakenDate=?, boxCapacity=?, lastBoxOpenedDate=?, newBoxScheduledDate=?, doseTakenCount=? where id = ?';
        var bindingvalues = [treatmentArrayObj.doseUnit, treatmentArrayObj.type, treatmentArrayObj.name, treatmentArrayObj.doseFrequency, treatmentArrayObj.doseFrequencyUnit, treatmentArrayObj.doseHour, treatmentArrayObj.doseMinute, treatmentArrayObj.lastDoseTakenDate, treatmentArrayObj.boxCapacity, treatmentArrayObj.lastBoxOpenedDate, treatmentArrayObj.newBoxScheduledDate, treatmentArrayObj.doseTakenCount, treatmentArrayObj.id];
        DB.query(sqlQuery, bindingvalues).then(function(result) {
                var sqlQuery = 'select * from MedicineExt where medicineId = ?'; 
                var bindingvalues = [treatmentArrayObj.id];
                DB.query(sqlQuery, bindingvalues).then(function(result) {
                      var medicineExtCount = result.rows.length;

                      if(medicineExtCount > 0) {
                          var sqlQuery1 = 'update MedicineExt set medicineType=?, durationType=?, reminderMatin=?, reminderMidi=?, reminderSoir=?, boiteNote=?, fileName=?, medicineIntake=?, deleteNotifyFlag=?, lastIgnoreDate=?, doseFrequencyUnitValue=?, durationValue=?, matinStatus=?, midiStatus=?, soirStatus=?, medicineStartDate=?, reminderOther=?, otherStatus=? where medicineId = ?';
                          var bindingvalues1 = [treatmentArrayObj.medicineType, treatmentArrayObj.durationType, treatmentArrayObj.reminderMatin, treatmentArrayObj.reminderMidi, treatmentArrayObj.reminderSoir, treatmentArrayObj.boiteNote, treatmentArrayObj.fileName, treatmentArrayObj.medicineIntake, treatmentArrayObj.deleteNotifyFlag, treatmentArrayObj.lastIgnoreDate, treatmentArrayObj.doseFrequencyUnitValue, treatmentArrayObj.durationValue, treatmentArrayObj.matinStatus, treatmentArrayObj.midiStatus, treatmentArrayObj.soirStatus, treatmentArrayObj.medicineStartDate, treatmentArrayObj.reminderOther, treatmentArrayObj.otherStatus, treatmentArrayObj.id];
                          DB.query(sqlQuery1, bindingvalues1).then(function(result) {
                            deferred.resolve(result);
                          },function(error){
                            console.log("Error Updating MedicineExt Data");
                             deferred.reject(error);
                          });
                      } else {
                          var sqlQuery1 = 'insert or replace into MedicineExt(medicineId, medicineType, durationType, reminderMatin, reminderMidi, reminderSoir, boiteNote, fileName, medicineIntake, deleteNotifyFlag, lastIgnoreDate, doseFrequencyUnitValue, durationValue, matinStatus, midiStatus, soirStatus, medicineStartDate, reminderOther, otherStatus) values (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)';
                          var bindingvalues1 = [treatmentArrayObj.id, treatmentArrayObj.medicineType, treatmentArrayObj.durationType, treatmentArrayObj.reminderMatin, treatmentArrayObj.reminderMidi, treatmentArrayObj.reminderSoir, treatmentArrayObj.boiteNote, treatmentArrayObj.fileName, treatmentArrayObj.medicineIntake, treatmentArrayObj.deleteNotifyFlag, treatmentArrayObj.lastIgnoreDate, treatmentArrayObj.doseFrequencyUnitValue, treatmentArrayObj.durationValue, treatmentArrayObj.matinStatus, treatmentArrayObj.midiStatus, treatmentArrayObj.soirStatus, treatmentArrayObj.medicineStartDate, treatmentArrayObj.reminderOther, treatmentArrayObj.otherStatus];
                          DB.query(sqlQuery1,bindingvalues1).then(function(result) {
                             deferred.resolve(result);
                          },function(error){
                              console.log("Problem inserting extended medicine data into MedicineExt DB");
                              deferred.reject(error);
                          });
                      }
                },function(error) {
                    console.log("Error Checking MedicineExt Record Exists");
                    deferred.reject(error);
                });
        },function(error) {
            console.log("Error Updating Medicine Data");
            deferred.reject(error);
        });
       return deferred.promise;
   };

   self.updateTabletTakenCount = function(columnName, rowId, columnValue, takenCount){
      var deferred = $q.defer();
      var sqlQuery = 'UPDATE Medicine SET lastDoseTakenDate=?, doseTakenCount=? WHERE id=?';
      var bindingvalues = [columnValue, takenCount, rowId];
      DB.query(sqlQuery, bindingvalues).then(function(result) {
          var sqlQuery1 = 'UPDATE MedicineExt SET '+columnName+'Status=? WHERE id=?';
          var bindingvalues1 = [columnValue, rowId];
          DB.query(sqlQuery1, bindingvalues1).then(function(result) {
              deferred.resolve(result);
          },function(error){
              console.log("ERROR: Update failed for Tablet taken count on Table MedicineExt");
              deferred.reject(error);
          });
      },function(error){
          console.log("ERROR: Update failed for Tablet taken count on Table Medicine");
          deferred.reject(error);
      });
      return deferred.promise;
   }


   self.updateDosageIgnoreDetails = function(columnName, rowId, columnValue){
      var deferred = $q.defer();
      var sqlQuery1 = 'UPDATE MedicineExt SET '+columnName+'Status=? WHERE id=?';
      var bindingvalues1 = [columnValue, rowId];
      DB.query(sqlQuery1, bindingvalues1).then(function(result) {
          deferred.resolve(result);
      },function(error){
          console.log("ERROR: Update failed for Ignore details on Table MedicineExt");
          deferred.reject(error);
      });
      return deferred.promise;
   }
                                                                       
   self.deleteTreatmentMedicine = function(treatmentArrayObj){
        var deferred = $q.defer();
        var sqlQuery = 'delete from MedicineExt where id=?';
        var bindingvalues = [treatmentArrayObj.id];
        DB.query(sqlQuery,bindingvalues).then(function(result){
            var sqlQuery1 = 'delete from Medicine where id=?';
            var bindingvalues1 = [treatmentArrayObj.id];
            DB.query(sqlQuery1,bindingvalues1).then(function(result){
            deferred.resolve(result);
            },function(error){
                deferred.reject(error);
            });
        },function(error){deferred.reject(error);});
        return deferred.promise;
   };
      
   self.selectAllTreatmentMedicines = function(){
        var sqlQuery = 'select m.id, m.doseUnit, m.type, m.name, m.doseFrequency, m.doseFrequencyUnit, m.doseHour, m.doseMinute, m.lastDoseTakenDate, m.boxCapacity, m.lastBoxOpenedDate, m.newBoxScheduledDate, m.doseTakenCount, e.medicineType, e.durationType, e.reminderMatin, e.reminderMidi, e.reminderSoir, e.boiteNote, e.fileName, e.medicineIntake, e.deleteNotifyFlag, e.lastIgnoreDate, e.doseFrequencyUnitValue, e.durationValue, e.matinStatus, e.midiStatus, e.soirStatus, e.medicineStartDate, e.reminderOther, e.otherStatus from Medicine m LEFT JOIN MedicineExt e ON m.id = e.medicineId';
        return DB.query(sqlQuery).then(function(result){
         return result;
        },function(error){
          console.log("Error reading medicine Data : "+error);
          return error});
   };

   self.getTreatmentMedicine = function(type) {
       var filteredData = [];
        var treatMedConCount = self.treatmentArray.length;
        for(var i=0;i<treatMedConCount;i++) {
          if(self.treatmentArray[i].type === parseInt(type)) {
              filteredData.push(self.treatmentArray[i]);
          }
        }
       return filteredData;
    };

    self.fetchTreamentMasterList = function() {
        var tempArray = [];
        var treatmentDosageList = [
          {listId: "1", listType:"tablet",  listName: $translate.instant('TREATMENTS_LIST_ITEM1')},
          {listId: "2", listType:"effervescent",  listName: $translate.instant('TREATMENTS_LIST_ITEM2')},
          {listId: "3", listType:"capsule", listName: $translate.instant('TREATMENTS_LIST_ITEM3')},
          {listId: "4", listType:"granules",  listName: $translate.instant('TREATMENTS_LIST_ITEM4')},
          {listId: "5", listType:"syrup",  listName: $translate.instant('TREATMENTS_LIST_ITEM5')},
          {listId: "6", listType:"oinment",  listName: $translate.instant('TREATMENTS_LIST_ITEM6')},
          {listId: "7", listType:"patch",  listName: $translate.instant('TREATMENTS_LIST_ITEM7')},
          {listId: "8", listType:"injection",  listName: $translate.instant('TREATMENTS_LIST_ITEM8')},
          {listId: "9", listType:"inhalation", listName: $translate.instant('TREATMENTS_LIST_ITEM9')},
          {listId: "10", listType:"suppository", listName: $translate.instant('TREATMENTS_LIST_ITEM10')},
          {listId: "11", listType:"bulb", listName: $translate.instant('TREATMENTS_LIST_ITEM11')},
          {listId: "12", listType:"drops", listName: $translate.instant('TREATMENTS_LIST_ITEM12')}
      ];
        var medicineTakePlace = [$translate.instant('AVANT_LE_REPAS'),$translate.instant('PENDANT_LE_REPAS'),$translate.instant('APRES_LE_REPAS')];
        self.selectAllTreatmentMedicines().then(function(result){
            var treatmentCount = result.rows.length;
            for(var i=0;i<treatmentCount;i++){
                var objList = result.rows.item(i);
                objList.name = aesUtil.decrypt(salt, iv, passPhrase, objList.name);
                objList.boiteNote = aesUtil.decrypt(salt, iv, passPhrase, objList.boiteNote);
                var dosageItemNo = parseInt(result.rows.item(i).medicineType) - 1;
                var medicineTakeType = parseInt(result.rows.item(i).medicineIntake) - 1;
                var currentDate = new Date();
                currentDate.setHours(0);
                currentDate.setMinutes(0);
                currentDate.setSeconds(0);
                var currDateSecs = Date.parse(currentDate);
                
                if(objList.medicineIntake == null){
                    objList.medicineIntake = 0;
                }

                if(objList.doseTakenCount == null || objList.doseTakenCount === ""){
                    objList.doseTakenCount = 0;
                }

                objList.dataPosition = i;
                objList.treatmentTypeName = (!isNaN(dosageItemNo))?treatmentDosageList[dosageItemNo].listName+"(s)":"";
                objList.treatmentTypeIcon = (!isNaN(dosageItemNo))?treatmentDosageList[dosageItemNo].listType:"";
                objList.medicineTakeName = (medicineTakeType !== undefined)?medicineTakePlace[medicineTakeType]:"";
                var matinCurrStatus = null, midiCurrStatus = null, soirCurrStatus = null;
                var matinCurrStatus1 = null, midiCurrStatus1 = null, soirCurrStatus1 = null;
                  
                objList.showPrescriptionRefill = 1;
                if(localStorage.getItem("PRESC_TREATID_POSTPONE"+objList.id) !== undefined && Date.parse(new Date()) >= Date.parse(localStorage.getItem("PRESC_TREATID_POSTPONE"+objList.id))){
                  objList.showPrescriptionRefill = 1;
                  localStorage.setItem("PRESC_TREATID_RENEWED"+objList.id, false);
                }

                if(localStorage.getItem("PRESC_TREATID_RENEWED"+objList.id) !== undefined && localStorage.getItem("PRESC_TREATID_RENEWED"+objList.id) === "false"){
                  objList.showPrescriptionRefill = 1;
                } else{
                  objList.showPrescriptionRefill = 0;
                }

                if(localStorage.getItem("PRESC_TREATID_RENEWED"+objList.id) ==  null){
                  objList.showPrescriptionRefill = 1; 
                }

                  
                objList.reminderMatinShow = objList.reminderMatin;
                if(objList.matinStatus != null){
                  var matinJsonObj = JSON.parse(objList.matinStatus);
                  if(matinJsonObj[currDateSecs] !== undefined && matinJsonObj[currDateSecs]["tablettaken"] !== undefined)
                    matinCurrStatus = self.fn_DateCompare(new Date(),matinJsonObj[currDateSecs]["tablettaken"]);

                  if(matinJsonObj[currDateSecs] !== undefined && matinJsonObj[currDateSecs]["newTime"] !== undefined &&  parseFloat(Date.parse(new Date())) < parseFloat(matinJsonObj[currDateSecs]["newTime"]))
                    objList.reminderMatinShow = 0;

                  if(matinJsonObj[currDateSecs] !== undefined && matinJsonObj[currDateSecs]["deleted"] !== undefined && matinJsonObj[currDateSecs]["deleted"] === true){
                    objList.reminderMatinShow = 0;
                  }                   
                } 

                objList.reminderMidiShow = objList.reminderMidi;
                if(objList.midiStatus != null){
                  var midiJsonObj = JSON.parse(objList.midiStatus);
                  if(midiJsonObj[currDateSecs] !== undefined && midiJsonObj[currDateSecs]["tablettaken"] !== undefined)
                    midiCurrStatus = self.fn_DateCompare(new Date(),midiJsonObj[currDateSecs]["tablettaken"]);

                  if(midiJsonObj[currDateSecs] !== undefined && midiJsonObj[currDateSecs]["newTime"] !== undefined &&  parseFloat(Date.parse(new Date())) < parseFloat(midiJsonObj[currDateSecs]["newTime"]))
                    objList.reminderMidiShow = 0;

                  if(midiJsonObj[currDateSecs] !== undefined && midiJsonObj[currDateSecs]["deleted"] !== undefined &&  midiJsonObj[currDateSecs]["deleted"] === true)
                    objList.reminderMidiShow = 0;
                }

                objList.reminderSoirShow = objList.reminderSoir;
                if(objList.soirStatus != null){
                  var soirJsonObj = JSON.parse(objList.soirStatus);
                  if(soirJsonObj[currDateSecs] !== undefined && soirJsonObj[currDateSecs]["tablettaken"] !== undefined)
                    soirCurrStatus = self.fn_DateCompare(new Date(),soirJsonObj[currDateSecs]["tablettaken"]);

                  if(soirJsonObj[currDateSecs] !== undefined && soirJsonObj[currDateSecs]["newTime"] !== undefined &&  parseFloat(Date.parse(new Date())) < parseFloat(soirJsonObj[currDateSecs]["newTime"]))
                    objList.reminderSoirShow = 0;

                  if(soirJsonObj[currDateSecs] !== undefined && soirJsonObj[currDateSecs]["deleted"] !== undefined &&  soirJsonObj[currDateSecs]["deleted"] === true)
                    objList.reminderSoirShow = 0;
                }
          
                objList.trackTakenCount = objList.doseTakenCount;

                var timeSlots = [];
                    var timeSlotLength = 0;
                    if(parseInt(objList.reminderMatin)===1){
                        timeSlots.push({index:timeSlotLength, id:parseInt(timeSlotLength)+1, customId:0, value: $translate.instant('MATIN'), meal:objList.medicineTakeName, type:"matin", showlist:objList.reminderMatinShow, treatmentStatus:(matinCurrStatus != null && matinCurrStatus === 0)?"inactive":"active"});
                        timeSlotLength += 1;
                    }

                    if(parseInt(objList.reminderMidi)===1){
                        timeSlots.push({index:timeSlotLength, id:parseInt(timeSlotLength)+1, customId:0, value: $translate.instant('MIDI'), meal:objList.medicineTakeName, type:"midi", showlist:objList.reminderMidiShow, treatmentStatus:(midiCurrStatus != null && midiCurrStatus === 0)?"inactive":"active"});
                        timeSlotLength += 1;
                    }

                    if(parseInt(objList.reminderSoir)===1){
                        timeSlots.push({index:timeSlotLength, id:parseInt(timeSlotLength)+1, customId:0, value: $translate.instant('SOIR'), meal:objList.medicineTakeName,type:"soir", showlist:objList.reminderSoirShow, treatmentStatus:(soirCurrStatus != null && soirCurrStatus === 0)?"inactive":"active"});
                        timeSlotLength += 1;
                    }

                    if(objList.reminderOther !== ""){
                          var slotListObj = JSON.parse(objList.reminderOther);
                          for(var iSlot in slotListObj){
                              var customListId = parseInt(iSlot)+1;
                              var customCurrStatus = null;
                              var customListShow = 1;
                              if(objList.otherStatus !== "" && objList.otherStatus != null){
                                var otherJsonObj = JSON.parse(objList.otherStatus);
                                if(otherJsonObj["OTHERID"+customListId] !== undefined && otherJsonObj["OTHERID"+customListId][currDateSecs] !== undefined && otherJsonObj["OTHERID"+customListId][currDateSecs]["tablettaken"] !== undefined)
                                  customCurrStatus = self.fn_DateCompare(new Date(),otherJsonObj["OTHERID"+customListId][currDateSecs]["tablettaken"]);

                                if(otherJsonObj["OTHERID"+customListId] !== undefined && otherJsonObj["OTHERID"+customListId][currDateSecs] !== undefined && otherJsonObj["OTHERID"+customListId][currDateSecs]["newTime"] !== undefined){
                                  if(parseFloat(Date.parse(new Date())) < parseFloat(otherJsonObj["OTHERID"+customListId][currDateSecs]["newTime"]))
                                    customListShow = 0;
                                } 

                                if(otherJsonObj["OTHERID"+customListId] !== undefined && otherJsonObj["OTHERID"+customListId][currDateSecs] !== undefined && otherJsonObj["OTHERID"+customListId][currDateSecs]["deleted"] !== undefined &&  otherJsonObj["OTHERID"+customListId][currDateSecs]["deleted"] === true)
                                  customListShow = 0;
                                      }
                              timeSlots.push({index:timeSlotLength, id:parseInt(timeSlotLength)+1, customId:parseInt(iSlot)+1, value: slotListObj[iSlot].value, meal:"",type:"other", showlist:customListShow, treatmentStatus:(customCurrStatus != null && customCurrStatus === 0)?"inactive":"active"});
                              timeSlotLength += 1; 
                          }
                    }

                      if(objList.doseHour != null && objList.doseMinute != null) {
                          objList.durationType = 1;
                          var doseHourArray = objList.doseHour.split("!");
                          var doseMinuteArray = objList.doseMinute.split("!");
                          var countSlot = 0;
                          for(var iSlot in doseHourArray) {
                              if(!isNaN(doseHourArray[iSlot])) {
                                  var customListId = parseInt(countSlot)+1;
                                    var customCurrStatus = null;
                                  var customListShow = 1;
                                if(objList.otherStatus !== "" && objList.otherStatus != null){
                                  var otherJsonObj = JSON.parse(objList.otherStatus);
                                  if(otherJsonObj["OTHERID"+customListId] !== undefined && otherJsonObj["OTHERID"+customListId][currDateSecs] !== undefined && otherJsonObj["OTHERID"+customListId][currDateSecs]["tablettaken"] !== undefined)
                            customCurrStatus = self.fn_DateCompare(new Date(),otherJsonObj["OTHERID"+customListId][currDateSecs]["tablettaken"]);

                          if(otherJsonObj["OTHERID"+customListId] !== undefined && otherJsonObj["OTHERID"+customListId][currDateSecs] !== undefined && otherJsonObj["OTHERID"+customListId][currDateSecs]["newTime"] !== undefined){
                            if(parseFloat(Date.parse(new Date())) < parseFloat(otherJsonObj["OTHERID"+customListId][currDateSecs]["newTime"]))
                              customListShow = 0;
                          } 

                          if(otherJsonObj["OTHERID"+customListId] !== undefined && otherJsonObj["OTHERID"+customListId][currDateSecs] !== undefined && otherJsonObj["OTHERID"+customListId][currDateSecs]["deleted"] !== undefined &&  otherJsonObj["OTHERID"+customListId][currDateSecs]["deleted"] === true)
                            customListShow = 0;
                                }
                                  var timeSlotValue;
                                  timeSlotValue = ((doseHourArray[iSlot]) < 10) ? "0"+doseHourArray[iSlot]+ " h " : doseHourArray[iSlot]+ " h ";
                                  timeSlotValue += ((doseMinuteArray[iSlot]) < 10) ? "0"+doseMinuteArray[iSlot] : doseMinuteArray[iSlot];
                                  timeSlots.push({index:timeSlotLength, id:parseInt(timeSlotLength)+1, customId:customListId, value: timeSlotValue, meal:"",type:"other", showlist:customListShow, treatmentStatus:(customCurrStatus != null && customCurrStatus === 0)?"inactive":"active"});
                                  timeSlotLength += 1;
                                  countSlot += 1;
                              } 
                          }

                          var doseFrequenceUnit = objList.doseFrequencyUnit;
                          var lastBoxDate = new Date();
                          if(objList.lastBoxOpenedDate !== null){
                            lastBoxDate = new Date(objList.lastBoxOpenedDate);
                          } 
                          objList.medicineStartDate = lastBoxDate;
                          if(objList.doseTakenCount === null || objList.doseTakenCount === "null" || objList.doseTakenCount === undefined || objList.doseTakenCount === "undefined"){
                            objList.doseTakenCount = 0;
                            objList.trackTakenCount = 0;
                          }
                          if(doseFrequenceUnit == 2) {
                            
                            objList.doseFrequencyUnit = 4;
                            objList.doseFrequencyUnitValue = "2,1";

                          } else if(doseFrequenceUnit == 3) {
                            
                            objList.doseFrequencyUnit = 2;
                            var treatmentDay = parseInt(lastBoxDate.getDay());
                            objList.doseFrequencyUnitValue = (treatmentDay == 0) ? 7 : treatmentDay;                            


                          } else if(doseFrequenceUnit == 4) {
                            
                            objList.doseFrequencyUnit = 3;
                            objList.doseFrequencyUnitValue = parseInt(lastBoxDate.getDate());;

                          }
                      }

                    objList.timeSlotsList = timeSlots;
                    tempArray.push(objList);
            }
            self.masterFetchedArray = tempArray;
        } ,function(error){
            console.log("Error reading Treatment Data : "+error);
        });
    };

    self.fn_DateCompare = function (DateA, DateB) {
        var a = new Date(DateA);
        a.setHours(0);
        a.setMinutes(0);
        a.setSeconds(0);
        var b = new Date(DateB);
        b.setHours(0);
        b.setMinutes(0);
        b.setSeconds(0);
        var msDateA = Date.parse(a);//Date.UTC(a.getFullYear(), a.getMonth()+1, a.getDate());
        var msDateB = Date.parse(b);//Date.UTC(b.getFullYear(), b.getMonth()+1, b.getDate());
        if (parseFloat(msDateA) < parseFloat(msDateB))
          return -1;  // lt
        else if (parseFloat(msDateA) == parseFloat(msDateB))
          return 0;  // eq
        else if (parseFloat(msDateA) > parseFloat(msDateB))
          return 1;  // gt
        else
          return null;  // error
    };

    self.treatmentOnDate = function(dateObj){
        var dashBoardDate = new Date(dateObj);
        var treatmentListLength = self.masterFetchedArray.length; 
        var treatmentitems = self.masterFetchedArray;
        if(treatmentListLength > 0){
        var tempTreatmentList = [];
        for(var i=0;i< treatmentitems.length;i++){
        //treatmentitems[i].formattedRowInfo = self.getMedicineInfo(treatmentitems[i]);
        //treatmentitems[i].icontype = (treatmentitems[i].medicineType!=null && treatmentitems[i].medicineType != "")?self.treatmentlist[treatmentitems[i].medicineType-1].listType:"";
          
          var frequencyType = treatmentitems[i].doseFrequencyUnit;
          var trtObjTemp = treatmentitems[i];
          var treatmentStartDate = new Date(trtObjTemp.medicineStartDate);
          if(self.fn_DateCompare(treatmentStartDate,dateObj) > 0)
          {
              //return [];
          }
          var currentDate = dashBoardDate;
          var resultDate = self.fn_DateCompare(treatmentStartDate,currentDate);
          var durationType = trtObjTemp.durationType;
          var durationValue = null; var durationNo = null; var durationValueType = null;
          var noOfDurationDays = 0
          var treatmentEndDate = new Date();
          if(durationType == 0 || durationType == "0"){
            durationValue = trtObjTemp.durationValue.split(",");
            durationNo = parseInt(durationValue[0]);
            durationValueType = parseInt(durationValue[1]);
            switch(durationValueType){
              case 1: noOfDurationDays = durationNo - 1;
                  break;
              case 2: noOfDurationDays = durationNo * 7;
                  noOfDurationDays--;
                  break;
              case 3: noOfDurationDays = durationNo * 30;
                  noOfDurationDays--;
                  break;
            }
            treatmentEndDate = new Date(treatmentStartDate.getTime() + (noOfDurationDays * 24 * 60 * 60 * 1000));
          } else{
            treatmentEndDate = new Date(dateObj.getTime() + (24 * 60 * 60 * 1000));
          }
          var resultEndDate = self.fn_DateCompare(treatmentEndDate,currentDate);
          switch(parseInt(frequencyType)){
            case 1:
                var objList = treatmentitems[i];
                if(resultDate <= 0 && resultEndDate>=0){
                  var checkPostponed = dashBoardDate;
                  checkPostponed.setHours(0);
                    checkPostponed.setMinutes(0);
                    checkPostponed.setSeconds(0);
                  var checkFlag = false;
                  var currDateSecs = Date.parse(checkPostponed);
                  objList.dataPosition = tempTreatmentList.length;
                  objList.dayRemaining = Math.floor((objList.boxCapacity - objList.doseTakenCount)/(objList.doseUnit * objList.doseFrequency));
                    
                  tempTreatmentList.push(objList);
                } 
                break;
            case 2:
              var dayObjCount = dashBoardDate.getDay();
              var objList = treatmentitems[i];
              if(dayObjCount == 0){
                dayObjCount = 7;
              }
                if(dayObjCount == parseInt(objList.doseFrequencyUnitValue) && resultDate <= 0 &&   resultEndDate>=0){
                  objList.dataPosition = tempTreatmentList.length;
                  objList.dayRemaining = Math.floor((objList.boxCapacity - objList.doseTakenCount)/(objList.doseUnit * objList.doseFrequency));
                  tempTreatmentList.push(objList);
                }
                break;
            case 3:
              var objList = treatmentitems[i];
              if(dashBoardDate.getDate() == parseInt(objList.doseFrequencyUnitValue) && resultDate <= 0 &&  resultEndDate>=0){
                objList.dataPosition = tempTreatmentList.length;
                objList.dayRemaining = Math.floor((objList.boxCapacity - objList.doseTakenCount)/(objList.doseUnit * objList.doseFrequency));
                tempTreatmentList.push(objList);
              }
              break;
            case 4:
              var objList = treatmentitems[i];
              var arraySeqObj = objList.doseFrequencyUnitValue.split(",");
              var noOfDays = 0;
              if(parseInt(arraySeqObj[1]) == 1){
                noOfDays = parseInt(arraySeqObj[0]); 
              } else if(parseInt(arraySeqObj[1]) == 2){
                noOfDays = parseInt(arraySeqObj[0]) * 7;
              } else{
                noOfDays = parseInt(arraySeqObj[0]) * 30;
              }
              var daysinMilliSeconds = noOfDays * 24 * 60 * 60 * 1000;
              var approxDate = new Date(treatmentStartDate.getTime() + daysinMilliSeconds);
              var nextDateResult = null; 
                        var breakFlag = true;
                        var dayCounter = 0;
                        while(breakFlag){
                            approxDate = new Date(treatmentStartDate.getTime() + (daysinMilliSeconds * dayCounter));
                            nextDateResult = self.fn_DateCompare(approxDate,currentDate);
                            if(nextDateResult == 0  && resultDate <= 0 &&  resultEndDate>=0){
                                breakFlag = false;
                                trtObjTemp.dataPosition = tempTreatmentList.length;
                  trtObjTemp.dayRemaining = Math.floor((trtObjTemp.boxCapacity - trtObjTemp.doseTakenCount)/(trtObjTemp.doseUnit * trtObjTemp.doseFrequency));
                  tempTreatmentList.push(trtObjTemp);
                            }
                            if(nextDateResult == 1){
                                breakFlag = false;
                            }
                            dayCounter++;
                  }
              break;
        }
        }
        return tempTreatmentList;
        
      }
    };
    
    self.treatmentlist = [
        {listId: "1", listType:"tablet",  listName: $translate.instant('TREATMENTS_LIST_ITEM1')},
        {listId: "2", listType:"effervescent",  listName: $translate.instant('TREATMENTS_LIST_ITEM2')},
        {listId: "3", listType:"capsule", listName: $translate.instant('TREATMENTS_LIST_ITEM3')},
        {listId: "4", listType:"granules",  listName: $translate.instant('TREATMENTS_LIST_ITEM4')},
        {listId: "5", listType:"syrup",  listName: $translate.instant('TREATMENTS_LIST_ITEM5')},
        {listId: "6", listType:"oinment",  listName: $translate.instant('TREATMENTS_LIST_ITEM6')},
        {listId: "7", listType:"patch",  listName: $translate.instant('TREATMENTS_LIST_ITEM7')},
        {listId: "8", listType:"injection",  listName: $translate.instant('TREATMENTS_LIST_ITEM8')},
        {listId: "9", listType:"inhalation", listName: $translate.instant('TREATMENTS_LIST_ITEM9')},
        {listId: "10", listType:"suppository", listName: $translate.instant('TREATMENTS_LIST_ITEM10')},
        {listId: "11", listType:"bulb", listName: $translate.instant('TREATMENTS_LIST_ITEM11')},
        {listId: "12", listType:"drops", listName: $translate.instant('TREATMENTS_LIST_ITEM12')}
    ];
    
    self.countTreatmentsByDateFromToDate = function(startDt, endDt){
        
        self.calendarTreatmentArray = [];
        
        var startDate = self.dateInMilliSeconds(startDt);
        var endDate = self.dateInMilliSeconds(endDt);
        for(;startDate<endDate;startDate+=24*60*60*1000){
            var treatmentList = self.treatmentOnDate(new Date(startDate));
            if(treatmentList && treatmentList.length>0){
                var dateFormat=$filter('date')(new Date(startDate), "dd MM yyyy");
                self.calendarTreatmentArray[dateFormat] = true;
            }
        }
        return self.calendarTreatmentArray;
  		
  };
  
  self.dateInMilliSeconds = function(dt){
          var milliSeconds = Date.parse(dt);
          return milliSeconds;
 };

    return self;
});